<?php

header('Content-Type: text/html; charset=utf-8');
date_default_timezone_set('America/Lima');
@include APPPATH . "/third_party/fpdf/fpdf.php";
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

class Courier extends MY_Controller {

    public function __construct() {
        parent::__construct();
        if (!isset($_SESSION['control']) || !isset($_SESSION['control']['idusuario'])) {
            redirect('Login/index/', 'refresh');
        }
        if (@$_SESSION['idperfil'] == "1" || @$_SESSION['idperfil'] == "2") {
            redirect('Home/index/', 'refresh');
        }
        $this->load->helper('file');
        $this->load->model("courier_model", "", true);
        $this->load->model("mantenimiento_model", "", true);
    }

    public function orden($servicio = "") {
        $data = $this->variablesSession();
        $data['empleado'] = $this->courier_model->select_table("usuario");
        $data['cliente'] = $this->courier_model->select_table('cliente');
        if ($servicio == "L") {
            $data['ubigeo'] = $this->courier_model->select_table_ubigeo('ubigeo', 'departamento', 'Lima');
        } else {
            $data['ubigeo'] = $this->courier_model->select_table('ubigeo');
        }
        $data['servicio'] = $servicio;
        $data['pagina'] = "courier";
        $this->load->view("include/head");
        $this->load->view("include/nav", $data);
        $this->load->view("courier/orden", $data);
        $this->load->view("include/footer");
    }

    public function actualizar($idcourier) {
        $data = $this->variablesSession();
        $data['empleado'] = $this->courier_model->select_table("usuario");
        $data['cliente'] = $this->courier_model->select_table('cliente');
        $data['orden'] = $this->mantenimiento_model->selectOrdenById("courier", $idcourier);
        $data['ubigeo'] = $this->courier_model->select_table('ubigeo');
        $data['pagina'] = "courier";
        $data['servicio'] = $data['orden']->tipo;
        $this->load->view("include/head");
        $this->load->view("include/nav", $data);
        $this->load->view("courier/orden", $data);
        $this->load->view("include/footer");
    }

    public function CambioEstado() {
        $data = $this->variablesSession();
        $insertar = $_POST;
        $insertar['fch_entrega'] = @date("Y:m:d H:i:s");
        $this->courier_model->update_table("courier", $insertar, $insertar['idcourier'], "idcourier");
        echo json_encode("success");
    }

    public function guardarIncidencia() {
        $data = $_POST;
        $this->courier_model->insert_table("incidencia", $data);
        echo json_encode("success");
    }

    public function insertarOrden() {
        $data = $this->variablesSession();
        $insertar = $_POST;
        $insertar['idusuario_crea'] = $data['idusuario'];
        if (@$insertar['idcourier'] != "") {
            $this->courier_model->update_table("courier", $insertar, $insertar['idcourier'], "idcourier");
        } else {
            $select = $this->courier_model->selectOrden("courier");
            $insertar['annio'] = @date("Y");
            if (isset($select) && $select != null && $select != '') {
                $valor = $select->nro_orden + 1;
                $insertar['nro_orden'] = sprintf('%06d', $valor);
            } else {
                $insertar['nro_orden'] = sprintf('%06d', 1);
            }
            $this->courier_model->insert_table("courier", $insertar);
        }
        echo json_encode("success");
    }

    public function seguimiento() {
        $data = $this->variablesSession();
        $data['courier'] = $this->courier_model->select_table("courier");
        $data['empleado'] = $this->courier_model->select_table("empleado", 'tipo', 'Mensajero');
        $data['empresa'] = $this->courier_model->select_table("empresa");
        $data['pagina'] = "seguimiento_courier";
        $this->load->view("include/head");
        $this->load->view("include/nav", $data);
        $this->load->view("courier/seguimiento");
        $this->load->view("include/footer");
    }

    public function selCliente() {
        $idcliente = $this->input->post("idcliente");
        $direccion = $this->courier_model->select_table('cliente', "idcliente", $idcliente);
        echo json_encode($direccion);
    }

    public function filtroCourier() {
        $idcourier = $this->input->post("idcourier");
        $array = $this->courier_model->select_table("courier", "idcourier", $idcourier);
        echo json_encode($array);
    }

    public function filtroMonitoreo() {
        $fch_desde = $this->input->post("fch_desde");
        $fch_hasta = $this->input->post("fch_hasta");
        $estado = $this->input->post("estado");
        $array = $this->courier_model->select_table_monitoreo($fch_desde, $fch_hasta, $estado);
        echo json_encode($array);
    }

    public function incidencias($param) {
        $data['idcourier'] = $param;
        $data['incidencias'] = $this->courier_model->select_table("incidencia", "idcourier", $param);
        $this->load->view("courier/incidencias", $data);
    }

    public function asignarOrdenCourier() {
        $data['idempleado'] = $this->input->post("idempleado");
        $data['idcourier'] = $this->input->post("idcourier");
        $data['idempresa'] = $this->input->post("idempresa");
        $data['estado'] = "2";
        if ($data['idempleado'] == "" && $data['idempresa'] == "") {
            echo json_encode("Error");
        } else {
            $this->courier_model->update_table("courier", $data, $data['idcourier'], "idcourier");
            echo json_encode("success");
        }
    }

    public function monitoreo() {
        $data = $this->variablesSession();
        $fecha = new DateTime();
        $fecha->modify('first day of this month');
        $data['primero'] = $fecha->format('d/m/Y');
        $data['desde'] = $fecha->format('Y-m-d');
        $fecha2 = new DateTime();
        $fecha2->modify('last day of this month');
        $data['ultimo'] = $fecha2->format('d/m/Y');
        $data['hasta'] = $fecha2->format('Y-m-d');
        $data['courier'] = $this->courier_model->select_table("courier");
        $data['usuario'] = $this->courier_model->select_table("usuario");
        $data['pagina'] = "monitoreo_courier";
        $this->load->view("include/head");
        $this->load->view("include/nav", $data);
        $this->load->view("courier/monitoreo", $data);
        $this->load->view("include/footer");
    }

    public function generarReporte() {
        $this->load->library('excel');
        $fch_desde = $this->input->post("fch_desde");
        $fch_hasta = $this->input->post("fch_hasta");
        $estado = $this->input->post("estado");
        $array['orden'] = $this->courier_model->select_table_monitoreo($fch_desde, $fch_hasta, $estado);
        $this->load->view("courier_rep", $array);
    }

    public function pdf($idcourier) {
        $data = $this->variablesSession();
        $orden = $this->mantenimiento_model->selectOrdenById("courier", $idcourier);
        $mipdf = new MiPDF('L', 'mm', array(140, 180));
        $mipdf->setVar(($orden->annio . "/" . $orden->nro_orden), $orden->cliente, $orden->contacto, $orden->telefono_contacto, $orden->direccion, $orden->observacion_crea);
        $mipdf->addPage();
        $mipdf->SetFont('Arial', 'B', 7);
        $mipdf->Output();
    }

}

class MiPDF extends FPDF {

    var $cliente;
    var $contacto;
    var $telefono;
    var $direccion;
    var $orden;
    var $observacion;

    public function Header() {
        $this->SetFont('Arial', 'B', 10);
        $this->Cell(0, 5, "Orden Courier: " . $this->orden, 0, 0, 'C');
        $this->Ln(10);
        $this->SetFont('Arial', '', 8);
        $this->Cell(0, 2, "Cliente: " . $this->cliente, 0, 0, '');
        $this->Ln(5);
        $this->Cell(0, 0, "Contacto: " . $this->contacto, 0, 0, '');
        $this->Ln(5);
        $this->Cell(0, 0, utf8_decode("Teléfono : ") . $this->telefono, 0, 0, '');
        $this->Ln(5);
        $this->Cell(0, 0, utf8_decode("Dirección : "), 0, 0, 'FJ');
        $this->Ln(5);
        $this->SetFont('Arial', '', 8);
        $direccion1 = substr($this->direccion, 0, 80);
        $direccion2 = substr($this->direccion, 80);
        $this->Cell(0, 0, $direccion1, 0, 0, 'FJ');
        $this->Ln(5);
        $this->Cell(0, 0, $direccion2, 0, 0, 'FJ');

        $observacion1 = substr($this->observacion, 0, 80);
        $observacion2 = substr($this->observacion, 80, 160);
        $observacion3 = substr($this->observacion, 160);
        $this->Ln(5);
        $this->Cell(0, 0, utf8_decode("Observación : "), 0, 0, 'FJ');
        $this->Ln(5);
        $this->Cell(0, 0, utf8_decode($observacion1), 0, 0, 'FJ');
        $this->Ln(5);
        $this->Cell(0, 0, utf8_decode($observacion2), 0, 0, 'FJ');
        $this->Ln(5);
        $this->Cell(0, 0, $observacion3, 0, 0, 'FJ');

        $this->Ln(10);
        $this->SetFont('Arial', 'B', 10);
        $this->Cell(0, 5, "Orden Courier: " . $this->orden, 0, 0, 'C');
        $this->Ln(10);
        $this->SetFont('Arial', '', 8);
        $this->Cell(0, 2, "Cliente: " . $this->cliente, 0, 0, '');
        $this->Ln(5);
        $this->Cell(0, 0, "Contacto: " . $this->contacto, 0, 0, '');
        $this->Ln(5);
        $this->Cell(0, 0, utf8_decode("Teléfono : ") . $this->telefono, 0, 0, '');
        $this->Ln(5);
        $this->Cell(0, 0, utf8_decode("Dirección : "), 0, 0, 'FJ');
        $this->Ln(5);
        $direccion1 = substr($this->direccion, 0, 80);
        $direccion2 = substr($this->direccion, 80);
        $this->Cell(0, 0, $direccion1, 0, 0, 'FJ');
        $this->Ln(5);
        $this->Cell(0, 0, $direccion2, 0, 0, 'FJ');

        $observacion1 = substr($this->observacion, 0, 80);
        $observacion2 = substr($this->observacion, 80, 160);
        $observacion3 = substr($this->observacion, 160);
        $this->Ln(5);
        $this->Cell(0, 0, utf8_decode("Observación : "), 0, 0, 'FJ');
        $this->Ln(5);
        $this->Cell(0, 0, utf8_decode($observacion1), 0, 0, 'FJ');
        $this->Ln(5);
        $this->Cell(0, 0, utf8_decode($observacion2), 0, 0, 'FJ');
        $this->Ln(5);
        $this->Cell(0, 0, $observacion3, 0, 0, 'FJ');
    }

    public function setVar($orden, $cliente, $contacto, $telefono, $direccion, $observacion) {
        $this->orden = $orden;
        $this->cliente = $cliente;
        $this->contacto = $contacto;
        $this->telefono = $telefono;
        $this->direccion = $direccion;
        $this->observacion = $observacion;
    }

}
