<?php
date_default_timezone_set('America/Lima');

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

class Courier_model extends CI_Model {

    public function __construct() {
        parent::__construct();
        $this->load->database();
    }

    function insert_table($tabla, $data) {
        if ($tabla == "courier") {
            $this->db->set('fch_creacion', 'NOW()', FALSE);
        }
        $this->db->insert($tabla, $data);
        return $this->db->insert_id();
    }

    function update_table($tabla, $data, $id, $campo) {
	if(@$data['estado'] == "3" || @$data['estado'] == "4"){
		$this->db->set('fch_entrega', 'NOW()', FALSE);
	}
        $this->db->where($campo, $id);
        $this->db->update($tabla, $data);
        return "success";
    }

    function selectMarcoHoy($idempleado) {
        $this->db->where('idempleado', $idempleado);
        $this->db->where('fecha', @date('Y-m-d'));
        $this->db->order_by("2 asc");
        $query = $this->db->get("asistencia");
        return $query->result_array();
    }

    function select_table($tabla, $tipo = "", $valor = "") {
        if ($tabla == "usuario") {
            $this->db->select("*");
            $this->db->select("(select (CONCAT((nombres), (' '), (apellidos))) from empleado where idempleado = usuario.idempleado) as nombres");
            $this->db->select("(select descripcion from perfil where idperfil = usuario.idperfil) as perfil");
            $this->db->where("estado = '1'");
            $this->db->where("idperfil = '5'");
        }
        if ($tabla == "courier") {
            $this->db->select("*");
            $this->db->select("(select usuario from usuario where idusuario = courier.idusuario_asignado) as usuario");
            $this->db->select("(select usuario from usuario where idusuario = courier.idusuario_crea) as usuario_crea");
        }
	if ($tabla == "courier") {
		$this->db->where("estado in ('1', '2', '4')");
		$this->db->order_by("2 desc, 3 desc");
	}else{ 
		$this->db->order_by("2 asc");
	}

        $this->db->limit(1000);
        $query = $this->db->get($tabla);
        return $query->result_array();
    }
    
    function select_table_monitoreo($tabla, $desde, $hasta, $estado) {
        if ($tabla == "usuario") {
            $this->db->select("*");
            $this->db->select("(select (CONCAT((nombres), (' '), (apellidos))) from empleado where idempleado = usuario.idempleado) as nombres");
            $this->db->select("(select descripcion from perfil where idperfil = usuario.idperfil) as perfil");
            $this->db->where("estado = '1'");
            $this->db->where("idperfil = '5'");
        }
        if ($tabla == "courier") {
            $this->db->select("*");
            $this->db->select("(select usuario from usuario where idusuario = courier.idusuario_asignado) as usuario");
            $this->db->select("(select usuario from usuario where idusuario = courier.idusuario_crea) as usuario_crea");
        }
        if($desde != ""){
            $this->db->where("fch_creacion >= '$desde'");
        } 
        if($hasta != ""){
            $this->db->where("fch_creacion <= '$hasta'");
        } 
        if($estado != ""){
            $this->db->where("estado", $estado);
        } 
	
        $this->db->order_by("2 desc, 3 desc");
        $query = $this->db->get($tabla);
        return $query->result_array();
    }

    function selectOrden($tabla) {
        if ($tabla == "courier") {
            $this->db->select('nro_orden');
        } else {
            $this->db->select('codigo');
        }
        $this->db->from($tabla);
        $this->db->where('annio', date("Y"));
        if ($tabla == "courier") {
            $this->db->order_by('nro_orden desc');
        } else {
            $this->db->select('codigo');
        }
        $this->db->limit(1);
        $query = $this->db->get();
        return $query->row();
    }

    function selectOrdenById($tabla, $id = "") {
        $this->db->from($tabla);
        if ($tabla != "asistencia") {
            $this->db->where('annio', date("Y"));
        }

        if ($id != "") {
            $this->db->where("id$tabla", $id);
        }
        if ($tabla != "asistencia") {
            $this->db->order_by('codigo desc');
        }

        $this->db->limit(1);
        $query = $this->db->get();
        return $query->row();
    }

    function reporteVisita($fch_desde) {
        $this->db->select("*");
        $this->db->select("(select (CONCAT((nombres), (' '), (apellidos))) from empleado where idempleado = visita.idempleado_visita) as nombre");
        $this->db->select("(select descripcion from motivo where idmotivo = visita.idmotivo) as motivo");
        $this->db->where('fecha', $fch_desde);
        $this->db->where("estado <> '3'");
        $this->db->order_by("2 asc");
        $query = $this->db->get("visita");
        return $query->result_array();
    }

    function reportePaquete($fch_desde) {
        $this->db->select("*");
        $this->db->select("(select (CONCAT((nombres), (' '), (apellidos))) from empleado where idempleado = paquetes_correo.idempleado_recepciona) as nombre");
        $this->db->where('fecha_recepcion', $fch_desde);
        $this->db->where("estado <> '3'");
        $this->db->order_by("2 asc");
        $query = $this->db->get("paquetes_correo");
        return $query->result_array();
    }

    public function reporteAsistencia($fch_desde, $fch_hasta) {
        $this->db->select("*");
        $this->db->select("(select (CONCAT((nombres), (' '), (apellidos))) from empleado where idempleado = asistencia.idempleado) as nombres");
        $this->db->where("fecha >= '$fch_desde'");
        $this->db->where("fecha <= '$fch_hasta'");
        $this->db->order_by("2 asc");
        $query = $this->db->get("asistencia");
        return $query->result_array();
    }

    public function selVisita($idvista) {
        $this->db->select("*");
        $this->db->select("(select (CONCAT((nombres), (' '), (apellidos))) from empleado where idempleado = visita.idempleado_visita) as nombre");
        $this->db->select("(select correo from empleado where idempleado = visita.idempleado_visita) as correo");
        $this->db->select("(select descripcion from motivo where idmotivo = visita.idmotivo) as motivo");
        $this->db->where("idvisita", $idvista);
        $query = $this->db->get("visita");
        return $query->result_array();
    }

    public function selPaqueteSeg($usuario) {
        $this->db->select("*");
        $this->db->select("(select (CONCAT((nombres), (' '), (apellidos))) from empleado where idempleado = paquetes_correo.idempleado_recepciona) as nombre");
        $this->db->where("idempleado_recepciona", $usuario);
        $this->db->where("((estado = '2') or (estado = '4') or (estado = '5'))");
        $this->db->order_by("2 desc, 3 desc");
        $query = $this->db->get("paquetes_correo");
        return $query->result_array();
    }

    public function selPaquete($id) {
        $this->db->select("*");
        $this->db->select("(select (CONCAT((nombres), (' '), (apellidos))) from empleado where idempleado = paquetes_correo.idempleado_recepciona) as nombre");
        $this->db->select("(select correo from empleado where idempleado = paquetes_correo.idempleado_recepciona) as correo");
        $this->db->where("idpaquetes_correo", $id);
        $query = $this->db->get("paquetes_correo");
        return $query->result_array();
    }

    public function selCourier($id) {
        $this->db->where("idusuario_asignado", $id);
	$this->db->where("estado in ('2', '5')");

        $query = $this->db->get("courier");
        return $query->result_array();
    }

    public function select_clientes($nombre = "") {
        $parametros = $this->load->database("sintad", true);
        $parametros->select("DISTINCT(nombre) as nombre, cliente");
        $parametros->select("direccion");
        if ($nombre != "") {
            $parametros->where("nombre", $nombre);
            $parametros->limit(1);
        }
        $parametros->order_by("1 desc");
        $query = $parametros->get('_clientes');
        return $query->result_array();
    }

    public function selCourierById($id) {
        $this->db->select("*");
        $this->db->select("(select usuario from usuario where idusuario = courier.idusuario_asignado) as user");
        $this->db->select("(select correo from empleado where idempleado = usuario.idempleado) as correo");
        $this->db->join('usuario', 'usuario.idusuario = courier.idusuario_crea');
        $this->db->where("idcourier", $id);
        $query = $this->db->get("courier");
        return $query->result_array();
    }

}
