const mDefaultDataTableInstance = {
    "pageLength": 10,
    "bLengthChange": true,
    "bFilter": true,
    "bProcessing": true,
    "pagingType": "full_numbers",
    "ordering": false,
    "oLanguage": {
        "sInfo": 'Nro de Registro: _START_ a _END_ de _TOTAL_',
        "sInfoEmpty": 'Hay un total de _TOTAL_ registros',
        "sEmptyTable": 'No hay registros para mostrar',
        "sZeroRecords": 'There are no matching <span class="lvllbl"></span>(s) to display',
        "sProcessing": 'Cargando',
        "oPaginate": {
            "sFirst": '<i class="fa fa-angle-double-left"></i>', // This is the link to the first page
            "sPrevious": '<i class="fa fa-angle-left"></i>', // This is the link to the previous page
            "sNext": '<i class="fa fa-angle-right"></i>', // This is the link to the next page
            "sLast": '<i class="fa fa-angle-double-right"></i>' // This is the link to the last page
        }
    },
    "rowCallback": function (row, data, index) {
        $('td', row).eq(0).addClass('text-center nowrap');
        $('td', row).eq(1).addClass('text-center nowrap');
        $('td', row).eq(2).addClass('text-center nowrap');
        $('td', row).eq(3).addClass('text-center nowrap');
        $('td', row).eq(4).addClass('text-center nowrap');
        if (data[2] == "1") {
            $('td', row).eq(2).html('Activo');
        } else {
            $('td', row).eq(2).html('Inactivo');
        }
        $('td', row).eq(0).html("<input id='idusuarioList' name='idusuarioList' type='hidden' value='" + data[5] + "'/>" + data[0] + "");
        $('td', row).eq(5).html("");
    }
};

var sampleTable;


$(document).ready(function () {
    sampleTable = $('#myTable').DataTable(mDefaultDataTableInstance);
    //validation();
    filtrarCursos(0);
    $('#myTable tbody').on('click', 'tr', function () {
        detalles($($(this).find("input")[0]).val());
        $('#myTable tbody tr').removeClass('table-info');
        $(this).addClass('table-info');
    });

});

var listarCursos = function (data) {
    sampleTable.clear();
    $.each(data, function (i, items) {
        sampleTable.row.add([
            items['usuario'],
            items['password'],
            items['estado'],
            items['perfil'],
            items['nombre'],
            items['idusuario']
        ]).draw();
    });
};

var cleanUsuario = function () {
    $("#idusuario").val("");
    $("#usuario").val("");
    $("#password").val("");
    $("#idperfil").val("");
    $("#idempleado").val("");
    $('#idempleado').trigger("chosen:updated");
    $("#idperfil").val("");
    $('#idperfil').trigger("chosen:updated");
    $("#estado").val("");
};

var filtrarCursos = function (parametro) {
    if (parametro == "1") {
        cleanUsuario();
    }
    $.ajax({
        url: 'filtrarCursos',
        type: 'POST',
        dataType: "json",
        beforeSend: function (jqXHR) {
            $("#spinner").show();
            $("#spinner button").unbind("click");
            $("#spinner button").click(function () {
                jqXHR.abort();
                $("#spinner").hide();
            });
        },
        success: function (data) {
            listarCursos(data);
        },
        complete: function () {
            $("#spinner").hide();
        }
    });
    $("#botonLimpiar").css("display", "inline");
    $("#botonCancelar").css("display", "none");
    $("#botonEliminar").css("display", "none");

};

var detalles = function (id) {
    $.ajax({
        url: 'filtrarCursos',
        type: 'POST',
        dataType: "json",
        beforeSend: function (jqXHR) {
            $("#spinner").show();
            $("#spinner button").unbind("click");
            $("#spinner button").click(function () {
                jqXHR.abort();
                $("#spinner").hide();
            });
        },
        data: {
            idusuario: id
        },
        success: function (data) {
            $("#idusuario").val(data[0]['idusuario']);
            $("#usuario").val(data[0]['usuario']);
            $("#password").val(data[0]['password']);
            $("#perfil").val(data[0]['perfil']);
            $("#idempleado").val(data[0]['idempleado']);
            $('#idempleado').trigger("chosen:updated");
            $("#idperfil").val(data[0]['idperfil']);
            $('#idperfil').trigger("chosen:updated");
            $("#estado").val(data[0]['estado']);
        },
        complete: function () {
            $("#spinner").hide();
        }
    });
};