window.chartColors = {
    red: 'rgb(255, 99, 132)',
    orange: 'rgb(255, 159, 64)',
    yellow: 'rgb(255, 205, 86)',
    green: 'rgb(75, 192, 192)',
    blue: 'rgb(54, 162, 235)',
    purple: 'rgb(153, 102, 255)',
    grey: 'rgb(201, 203, 207)'
};

let dataTable;

$(document).ready(function () {
    initTable();
    dataTable = $('#myTable').DataTable(mDefaultDataTableInstance);
    filtrar();
});


function filtrar(mes = "") {
    $.ajax({
        url: '/control/kpi/filtrarDim1',
        type: 'POST',
        data: {
            cliente: $("#cliente").val(),
            annio: $("#annio").val(),
            mes: $("#mes").val(),
            idreporte: $("#idreporte").val(),

        },
        dataType: "json",
        beforeSend: function (jqXHR) {
            $("#spinner").show();
            $("#spinner button").unbind("click");
            $("#spinner button").click(function () {
                jqXHR.abort();
                $("#spinner").hide();
            });
        },
        success: function (response) {

            dataTable
                .clear()
                .rows.add(response.tabla)
                .draw();

            /*$("#descripcion").val(response.reporte);
            $(".card.diagrama").html("");
            $(".card.diagrama").html("<h4 class='mb-3'>" + response.reporte + "</h4><canvas id='barChart'></canvas>");*/

            $("#titulo").html(response.reporte);
            var ctx = document.getElementById("barChart");

            const labels = response.data.map(function (t) { return t.fecha; });

            var myChart = new Chart(ctx, {
                type: 'line',
                data: {
                    labels: labels,
                    datasets: [
                        {
                            label: "Total",
                            data: response.data.map(function (t) { return t.totales; }),
                            backgroundColor: window.chartColors.green,
                            borderColor: window.chartColors.green,
                            fill: false,
                        },
                        {
                            label: "% Cumplimiento",
                            data: response.data.map(function (t) { return t.positivos; }),
                            backgroundColor: window.chartColors.blue,
                            borderColor: window.chartColors.blue,
                            fill: false,
                        },
                        {
                            label: "% Incumplimiento",
                            data: response.data.map(function (t) { return t.negativos; }),
                            backgroundColor: window.chartColors.red,
                            borderColor: window.chartColors.red,
                            fill: false,
                        }
                    ]
                },
                options: {
                    scales: {
                        yAxes: [{ ticks: { beginAtZero: true } }]
                    },
                    tooltips: {
                        enabled: false,
                        mode: 'index',
                        position: 'nearest',
                        custom: function (tooltipModel) {
                            // Tooltip Element
                            var tooltipEl = document.getElementById('chartjs-tooltip');

                            // Create element on first render
                            if (!tooltipEl) {
                                tooltipEl = document.createElement('div');
                                tooltipEl.id = 'chartjs-tooltip';
                                tooltipEl.innerHTML = '<table></table>';
                                document.body.appendChild(tooltipEl);
                            }

                            // Hide if no tooltip
                            if (tooltipModel.opacity === 0) {
                                tooltipEl.style.opacity = 0;
                                return;
                            }

                            // Set caret Position
                            tooltipEl.classList.remove('above', 'below', 'no-transform');
                            if (tooltipModel.yAlign) {
                                tooltipEl.classList.add(tooltipModel.yAlign);
                            } else {
                                tooltipEl.classList.add('no-transform');
                            }

                            function getBody(bodyItem) {
                                return bodyItem.lines;
                            }

                            // Set Text
                            if (tooltipModel.body) {
                                var titleLines = tooltipModel.title || [];
                                var bodyLines = tooltipModel.body.map(getBody);


                                var innerHtml = '<thead>';

                                titleLines.forEach(function (title) {
                                    innerHtml += '<tr><th>' + title + '</th></tr>';
                                });
                                innerHtml += '</thead><tbody>';

                                const total = bodyLines[0][0].split(": ")[1];
                                const cumplidos = bodyLines[1][0].split(": ")[1];
                                const noCumplidos = bodyLines[2][0].split(": ")[1];
                                const porcCumplidos = ((cumplidos * 100) / total).toFixed(2);
                                const porcNoCumplidos = ((noCumplidos * 100) / total).toFixed(2);


                                innerHtml += '<tr><td>' + bodyLines[0][0].split(": ")[0] + ': 100% - ' + total + ' dams</td></tr>';
                                innerHtml += '<tr><td>' + bodyLines[1][0].split(": ")[0] + ': ' + porcCumplidos + '% - ' + cumplidos + ' dams</td></tr>';
                                innerHtml += '<tr><td>' + bodyLines[2][0].split(": ")[0] + ': ' + porcNoCumplidos + '% - ' + noCumplidos + ' dams</td></tr>';


                                /* bodyLines.forEach(function(body, i) {
                                    var colors = tooltipModel.labelColors[i];
                                    var style = 'background:' + colors.backgroundColor;
                                    style += '; border-color:' + colors.borderColor;
                                    style += '; border-width: 2px';
                                    var span = '<span style="' + style + '"></span>';
                                    innerHtml += '<tr><td>' + span + body + '</td></tr>';
                                }); */
                                innerHtml += '</tbody>';

                                var tableRoot = tooltipEl.querySelector('table');
                                tableRoot.innerHTML = innerHtml;
                            }

                            // `this` will be the overall tooltip
                            var position = this._chart.canvas.getBoundingClientRect();

                            // Display, position, and set styles for font
                            tooltipEl.style.opacity = 1;
                            tooltipEl.style.position = 'absolute';
                            tooltipEl.style.left = position.left + window.pageXOffset + tooltipModel.caretX + 'px';
                            tooltipEl.style.top = position.top + window.pageYOffset + tooltipModel.caretY + 'px';
                            tooltipEl.style.fontFamily = tooltipModel._bodyFontFamily;
                            tooltipEl.style.fontSize = tooltipModel.bodyFontSize + 'px';
                            tooltipEl.style.fontStyle = tooltipModel._bodyFontStyle;
                            tooltipEl.style.padding = tooltipModel.yPadding + 'px ' + tooltipModel.xPadding + 'px';
                            tooltipEl.style.pointerEvents = 'none';
                            tooltipEl.style.backgroundColor = 'rgba(0, 0, 0, 0.59)';
                            tooltipEl.style.color = 'white';
                        }
                    }
                }
            });

        },
        complete: function () {
            $("#spinner").hide();
        }
    });
}


function removeadd() {
    $("#card").html("");
    $("#card").html("<h4 class='mb-3'>DAMS por Regimen </h4><canvas id='barChart'></canvas>");
}

function initTable() {
    mDefaultDataTableInstance = {
        "dom": 'Bfrtip',
        "pageLength": 10,
        "bLengthChange": true,
        "bFilter": true,
        "ordering": false,
        //"scrollX": true,
        //"scrollCollapse": true,
        //dom: "<'col-row'<'col-lg-6'B><'col-lg-6'f>><'col-lg-12't><'col-lg-12'i>",
        "bProcessing": true,
        "pagingType": "full_numbers",
        buttons: [
            'copy', 'csv', 'excel', 'pdf', 'print'
        ],
        "oLanguage": {
            "sInfo": 'Nro de Registro: _START_ a _END_ de _TOTAL_',
            "sInfoEmpty": 'Hay un total de _TOTAL_ registros',
            "sEmptyTable": 'No hay registros para mostrar',
            "sZeroRecords": 'There are no matching <span class="lvllbl"></span>(s) to display',
            "sProcessing": 'Cargando',
            "oPaginate": {
                "sFirst": '<i class="fa fa-angle-double-left"></i>', // This is the link to the first page
                "sPrevious": '<i class="fa fa-angle-left"></i>', // This is the link to the previous page
                "sNext": '<i class="fa fa-angle-right"></i>', // This is the link to the next page
                "sLast": '<i class="fa fa-angle-double-right"></i>' // This is the link to the last page
            }
        },
        "rowCallback": function (row, data, index) {
            $('td', row).eq(0).addClass('nowrap');
            $('td', row).eq(1).addClass('nowrap');
            $('td', row).eq(2).addClass('nowrap');
            $('td', row).eq(3).addClass('nowrap');
            $('td', row).eq(4).addClass('nowrap');
            $('td', row).eq(5).addClass('nowrap');
            $('td', row).eq(6).addClass('nowrap');
            $('td', row).eq(7).addClass('nowrap');
            $('td', row).eq(8).addClass('nowrap');
            $('td', row).eq(9).addClass('nowrap');
            $('td', row).eq(10).addClass('nowrap');
            $('td', row).eq(11).addClass('nowrap');
            $('td', row).eq(12).addClass('nowrap');
            $('td', row).eq(13).addClass('nowrap');
            $('td', row).eq(14).addClass('nowrap');
            $('td', row).eq(15).addClass('nowrap');
            $('td', row).eq(16).addClass('nowrap');
            $('td', row).eq(17).addClass('nowrap');
            $('td', row).eq(18).addClass('nowrap');
            $('td', row).eq(19).addClass('nowrap');
            $('td', row).eq(20).addClass('nowrap');
            $('td', row).eq(21).addClass('nowrap');
        }
    };
}



/*(function ($) {
    "use strict";
    var ctx = document.getElementById("team-chart");
    var myChart = new Chart(ctx, { type: 'line', data: { labels: ["2010", "2011", "2012", "2013", "2014", "2015", "2016"], type: 'line', defaultFontFamily: 'Montserrat', datasets: [{ data: [0, 7, 3, 5, 2, 10, 7], label: "Expense", backgroundColor: 'rgba(0,103,255,.15)', borderColor: 'rgba(0,103,255,0.5)', borderWidth: 3.5, pointStyle: 'circle', pointRadius: 5, pointBorderColor: 'transparent', pointBackgroundColor: 'rgba(0,103,255,0.5)', },] }, options: { responsive: true, tooltips: { mode: 'index', titleFontSize: 12, titleFontColor: '#000', bodyFontColor: '#000', backgroundColor: '#fff', titleFontFamily: 'Montserrat', bodyFontFamily: 'Montserrat', cornerRadius: 3, intersect: false, }, legend: { display: false, position: 'top', labels: { usePointStyle: true, fontFamily: 'Montserrat', }, }, scales: { xAxes: [{ display: true, gridLines: { display: false, drawBorder: false }, scaleLabel: { display: false, labelString: 'Month' } }], yAxes: [{ display: true, gridLines: { display: false, drawBorder: false }, scaleLabel: { display: true, labelString: 'Value' } }] }, title: { display: false, } } });
    var ctx = document.getElementById("sales-chart");
    ctx.height = 150;
    var myChart = new Chart(ctx, { type: 'line', data: { labels: ["2010", "2011", "2012", "2013", "2014", "2015", "2016"], type: 'line', defaultFontFamily: 'Montserrat', datasets: [{ label: "Foods", data: [0, 30, 10, 120, 50, 63, 10], backgroundColor: 'transparent', borderColor: 'rgba(220,53,69,0.75)', borderWidth: 3, pointStyle: 'circle', pointRadius: 5, pointBorderColor: 'transparent', pointBackgroundColor: 'rgba(220,53,69,0.75)', }, { label: "Electronics", data: [0, 50, 40, 80, 40, 79, 120], backgroundColor: 'transparent', borderColor: 'rgba(40,167,69,0.75)', borderWidth: 3, pointStyle: 'circle', pointRadius: 5, pointBorderColor: 'transparent', pointBackgroundColor: 'rgba(40,167,69,0.75)', }] }, options: { responsive: true, tooltips: { mode: 'index', titleFontSize: 12, titleFontColor: '#000', bodyFontColor: '#000', backgroundColor: '#fff', titleFontFamily: 'Montserrat', bodyFontFamily: 'Montserrat', cornerRadius: 3, intersect: false, }, legend: { display: false, labels: { usePointStyle: true, fontFamily: 'Montserrat', }, }, scales: { xAxes: [{ display: true, gridLines: { display: false, drawBorder: false }, scaleLabel: { display: false, labelString: 'Month' } }], yAxes: [{ display: true, gridLines: { display: false, drawBorder: false }, scaleLabel: { display: true, labelString: 'Value' } }] }, title: { display: false, text: 'Normal Legend' } } });
    var ctx = document.getElementById("lineChart");
    ctx.height = 150;
    var myChart = new Chart(ctx, { type: 'line', data: { labels: ["January", "February", "March", "April", "May", "June", "July"], datasets: [{ label: "My First dataset", borderColor: "rgba(0,0,0,.09)", borderWidth: "1", backgroundColor: "rgba(0,0,0,.07)", data: [22, 44, 67, 43, 76, 45, 12] }, { label: "My Second dataset", borderColor: "rgba(0, 123, 255, 0.9)", borderWidth: "1", backgroundColor: "rgba(0, 123, 255, 0.5)", pointHighlightStroke: "rgba(26,179,148,1)", data: [16, 32, 18, 26, 42, 33, 44] }] }, options: { responsive: true, tooltips: { mode: 'index', intersect: false }, hover: { mode: 'nearest', intersect: true } } });
    var ctx = document.getElementById("barChart");
    var myChart = new Chart(ctx, { type: 'bar', data: { labels: ["January", "February", "March", "April", "May", "June", "July"], datasets: [{ label: "My First dataset", data: [65, 59, 80, 81, 56, 55, 40], borderColor: "rgba(0, 123, 255, 0.9)", borderWidth: "0", backgroundColor: "rgba(0, 123, 255, 0.5)" }, { label: "My Second dataset", data: [28, 48, 40, 19, 86, 27, 90], borderColor: "rgba(0,0,0,0.09)", borderWidth: "0", backgroundColor: "rgba(0,0,0,0.07)" }] }, options: { scales: { yAxes: [{ ticks: { beginAtZero: true } }] } } });
    var ctx = document.getElementById("radarChart");
    ctx.height = 160;
    var myChart = new Chart(ctx, { type: 'radar', data: { labels: [["Eating", "Dinner"], ["Drinking", "Water"], "Sleeping", ["Designing", "Graphics"], "Coding", "Cycling", "Running"], datasets: [{ label: "My First dataset", data: [65, 59, 66, 45, 56, 55, 40], borderColor: "rgba(0, 123, 255, 0.6)", borderWidth: "1", backgroundColor: "rgba(0, 123, 255, 0.4)" }, { label: "My Second dataset", data: [28, 12, 40, 19, 63, 27, 87], borderColor: "rgba(0, 123, 255, 0.7", borderWidth: "1", backgroundColor: "rgba(0, 123, 255, 0.5)" }] }, options: { legend: { position: 'top' }, scale: { ticks: { beginAtZero: true } } } });
    var ctx = document.getElementById("pieChart");
    ctx.height = 300;
    var myChart = new Chart(ctx, { type: 'pie', data: { datasets: [{ data: [45, 25, 20, 10], backgroundColor: ["rgba(0, 123, 255,0.9)", "rgba(0, 123, 255,0.7)", "rgba(0, 123, 255,0.5)", "rgba(0,0,0,0.07)"], hoverBackgroundColor: ["rgba(0, 123, 255,0.9)", "rgba(0, 123, 255,0.7)", "rgba(0, 123, 255,0.5)", "rgba(0,0,0,0.07)"] }], labels: ["green", "green", "green"] }, options: { responsive: true } });
    var ctx = document.getElementById("doughutChart");
    ctx.height = 150;
    var myChart = new Chart(ctx, { type: 'doughnut', data: { datasets: [{ data: [45, 25, 20, 10], backgroundColor: ["rgba(0, 123, 255,0.9)", "rgba(0, 123, 255,0.7)", "rgba(0, 123, 255,0.5)", "rgba(0,0,0,0.07)"], hoverBackgroundColor: ["rgba(0, 123, 255,0.9)", "rgba(0, 123, 255,0.7)", "rgba(0, 123, 255,0.5)", "rgba(0,0,0,0.07)"] }], labels: ["green", "green", "green", "green"] }, options: { responsive: true } });
    var ctx = document.getElementById("polarChart");
    ctx.height = 150;
    var myChart = new Chart(ctx, { type: 'polarArea', data: { datasets: [{ data: [15, 18, 9, 6, 19], backgroundColor: ["rgba(0, 123, 255,0.9)", "rgba(0, 123, 255,0.8)", "rgba(0, 123, 255,0.7)", "rgba(0,0,0,0.2)", "rgba(0, 123, 255,0.5)"] }], labels: ["green", "green", "green", "green"] }, options: { responsive: true } });
    var ctx = document.getElementById("singelBarChart");
    ctx.height = 150;
    var myChart = new Chart(ctx, { type: 'bar', data: { labels: ["Sun", "Mon", "Tu", "Wed", "Th", "Fri", "Sat"], datasets: [{ label: "My First dataset", data: [40, 55, 75, 81, 56, 55, 40], borderColor: "rgba(0, 123, 255, 0.9)", borderWidth: "0", backgroundColor: "rgba(0, 123, 255, 0.5)" }] }, options: { scales: { yAxes: [{ ticks: { beginAtZero: true } }] } } });
})(jQuery);
*/