$(document).ready(function () {
    initTable();
    sampleTable = $('#myTable').DataTable(mDefaultDataTableInstance);
    filtrar();
});

function filtrar(mes = "") {
    $.ajax({
        url: '/control/reportes/filtrarDim2',
        type: 'POST',
        data: {
            cliente: $("#cliente").val(),
            annio: $("#annio").val(),
            mes: $("#mes").val()
        },
        dataType: "json",
        beforeSend: function (jqXHR) {
            $("#spinner").show();
            $("#spinner button").unbind("click");
            $("#spinner button").click(function () {
                jqXHR.abort();
                $("#spinner").hide();
            });
        },
        success: function (array) { 
            $(".card").html("");
            $(".card").html("<h4 class='mb-3'>DAMS por Regimen </h4><canvas id='barChart'></canvas>");
            var ctx = document.getElementById("barChart");

            var myChart = new Chart(ctx, {
                type: 'bar',
                data: {
                    labels: array['regimen'],
                    datasets: [
                        {
                            label: "DAMS Por Mes Diferido",
                            data: array['orden'],
                            borderColor: "rgba(0, 123, 255, 0.9)", borderWidth: "0",
                            backgroundColor: "rgba(0, 123, 255, 0.5)"
                        },
                        {
                            label: "Target 2 días",
                            data: array['target'],
                            borderColor: "rgba(210, 142, 142, 1)", borderWidth: "0",
                            backgroundColor: "rgba(210, 142, 142, 1)"
                        },
                        {
                            label: "DAMS Por Mes Ancipado",
                            data: array['ordens'],
                            borderColor: "rgba(0,0,0,0.09)",
                            borderWidth: "0",
                            backgroundColor: "rgba(0,0,0,0.07)"
                        },
                        {
                            label: "Target -2 días",
                            data: array['target2'],
                            borderColor: "rgba(210, 142, 142, 1)",
                            borderWidth: "0",
                            backgroundColor: "rgba(210, 142, 142, 1)"
                        }
                    ]
                },
                options:
                        {
                            scales: {
                                yAxes: [{ticks: {beginAtZero: true}}]
                            }
                        }
            });

        },
        complete: function () {
            $("#spinner").hide();
        }
    });
}


function removeadd() {
    $("#card").html("");
    $("#card").html("<h4 class='mb-3'>DAMS por Regimen </h4><canvas id='barChart'></canvas>");
}

function initTable() {
    mDefaultDataTableInstance = {
        "dom": 'Bfrtip',
        "pageLength": 10,
        "bLengthChange": true,
        "bFilter": true,
        "ordering": false,
        "scrollX": true,
        "scrollCollapse": true,
        "bProcessing": true,
        "pagingType": "full_numbers",
        buttons: [
            'copy', 'csv', 'excel', 'pdf', 'print'
        ],
        "oLanguage": {
            "sInfo": 'Nro de Registro: _START_ a _END_ de _TOTAL_',
            "sInfoEmpty": 'Hay un total de _TOTAL_ registros',
            "sEmptyTable": 'No hay registros para mostrar',
            "sZeroRecords": 'There are no matching <span class="lvllbl"></span>(s) to display',
            "sProcessing": 'Cargando',
            "oPaginate": {
                "sFirst": '<i class="fa fa-angle-double-left"></i>', // This is the link to the first page
                "sPrevious": '<i class="fa fa-angle-left"></i>', // This is the link to the previous page
                "sNext": '<i class="fa fa-angle-right"></i>', // This is the link to the next page
                "sLast": '<i class="fa fa-angle-double-right"></i>' // This is the link to the last page
            }
        },
        "rowCallback": function (row, data, index) {
            $('td', row).eq(0).addClass('nowrap');
            $('td', row).eq(1).addClass('nowrap');
            $('td', row).eq(2).addClass('nowrap');
            $('td', row).eq(3).addClass('nowrap');
            $('td', row).eq(4).addClass('nowrap');
            $('td', row).eq(5).addClass('nowrap');
            $('td', row).eq(6).addClass('nowrap');
            $('td', row).eq(7).addClass('nowrap');
            $('td', row).eq(8).addClass('nowrap');
            $('td', row).eq(9).addClass('nowrap');
            $('td', row).eq(10).addClass('nowrap');
            $('td', row).eq(11).addClass('nowrap');
            $('td', row).eq(12).addClass('nowrap');
            $('td', row).eq(13).addClass('nowrap');
            $('td', row).eq(14).addClass('nowrap');
            $('td', row).eq(15).addClass('nowrap');
            $('td', row).eq(16).addClass('nowrap');
            $('td', row).eq(17).addClass('nowrap');
            $('td', row).eq(18).addClass('nowrap');
            $('td', row).eq(19).addClass('nowrap');
            $('td', row).eq(20).addClass('nowrap');
            $('td', row).eq(21).addClass('nowrap');
        }
    };
}



(function ($) {
    "use strict";
    var ctx = document.getElementById("team-chart");
    var myChart = new Chart(ctx, {type: 'line', data: {labels: ["2010", "2011", "2012", "2013", "2014", "2015", "2016"], type: 'line', defaultFontFamily: 'Montserrat', datasets: [{data: [0, 7, 3, 5, 2, 10, 7], label: "Expense", backgroundColor: 'rgba(0,103,255,.15)', borderColor: 'rgba(0,103,255,0.5)', borderWidth: 3.5, pointStyle: 'circle', pointRadius: 5, pointBorderColor: 'transparent', pointBackgroundColor: 'rgba(0,103,255,0.5)', }, ]}, options: {responsive: true, tooltips: {mode: 'index', titleFontSize: 12, titleFontColor: '#000', bodyFontColor: '#000', backgroundColor: '#fff', titleFontFamily: 'Montserrat', bodyFontFamily: 'Montserrat', cornerRadius: 3, intersect: false, }, legend: {display: false, position: 'top', labels: {usePointStyle: true, fontFamily: 'Montserrat', }, }, scales: {xAxes: [{display: true, gridLines: {display: false, drawBorder: false}, scaleLabel: {display: false, labelString: 'Month'}}], yAxes: [{display: true, gridLines: {display: false, drawBorder: false}, scaleLabel: {display: true, labelString: 'Value'}}]}, title: {display: false, }}});
    var ctx = document.getElementById("sales-chart");
    ctx.height = 150;
    var myChart = new Chart(ctx, {type: 'line', data: {labels: ["2010", "2011", "2012", "2013", "2014", "2015", "2016"], type: 'line', defaultFontFamily: 'Montserrat', datasets: [{label: "Foods", data: [0, 30, 10, 120, 50, 63, 10], backgroundColor: 'transparent', borderColor: 'rgba(220,53,69,0.75)', borderWidth: 3, pointStyle: 'circle', pointRadius: 5, pointBorderColor: 'transparent', pointBackgroundColor: 'rgba(220,53,69,0.75)', }, {label: "Electronics", data: [0, 50, 40, 80, 40, 79, 120], backgroundColor: 'transparent', borderColor: 'rgba(40,167,69,0.75)', borderWidth: 3, pointStyle: 'circle', pointRadius: 5, pointBorderColor: 'transparent', pointBackgroundColor: 'rgba(40,167,69,0.75)', }]}, options: {responsive: true, tooltips: {mode: 'index', titleFontSize: 12, titleFontColor: '#000', bodyFontColor: '#000', backgroundColor: '#fff', titleFontFamily: 'Montserrat', bodyFontFamily: 'Montserrat', cornerRadius: 3, intersect: false, }, legend: {display: false, labels: {usePointStyle: true, fontFamily: 'Montserrat', }, }, scales: {xAxes: [{display: true, gridLines: {display: false, drawBorder: false}, scaleLabel: {display: false, labelString: 'Month'}}], yAxes: [{display: true, gridLines: {display: false, drawBorder: false}, scaleLabel: {display: true, labelString: 'Value'}}]}, title: {display: false, text: 'Normal Legend'}}});
    var ctx = document.getElementById("lineChart");
    ctx.height = 150;
    var myChart = new Chart(ctx, {type: 'line', data: {labels: ["January", "February", "March", "April", "May", "June", "July"], datasets: [{label: "My First dataset", borderColor: "rgba(0,0,0,.09)", borderWidth: "1", backgroundColor: "rgba(0,0,0,.07)", data: [22, 44, 67, 43, 76, 45, 12]}, {label: "My Second dataset", borderColor: "rgba(0, 123, 255, 0.9)", borderWidth: "1", backgroundColor: "rgba(0, 123, 255, 0.5)", pointHighlightStroke: "rgba(26,179,148,1)", data: [16, 32, 18, 26, 42, 33, 44]}]}, options: {responsive: true, tooltips: {mode: 'index', intersect: false}, hover: {mode: 'nearest', intersect: true}}});
    var ctx = document.getElementById("barChart");
    var myChart = new Chart(ctx, {type: 'bar', data: {labels: ["January", "February", "March", "April", "May", "June", "July"], datasets: [{label: "My First dataset", data: [65, 59, 80, 81, 56, 55, 40], borderColor: "rgba(0, 123, 255, 0.9)", borderWidth: "0", backgroundColor: "rgba(0, 123, 255, 0.5)"}, {label: "My Second dataset", data: [28, 48, 40, 19, 86, 27, 90], borderColor: "rgba(0,0,0,0.09)", borderWidth: "0", backgroundColor: "rgba(0,0,0,0.07)"}]}, options: {scales: {yAxes: [{ticks: {beginAtZero: true}}]}}});
    var ctx = document.getElementById("radarChart");
    ctx.height = 160;
    var myChart = new Chart(ctx, {type: 'radar', data: {labels: [["Eating", "Dinner"], ["Drinking", "Water"], "Sleeping", ["Designing", "Graphics"], "Coding", "Cycling", "Running"], datasets: [{label: "My First dataset", data: [65, 59, 66, 45, 56, 55, 40], borderColor: "rgba(0, 123, 255, 0.6)", borderWidth: "1", backgroundColor: "rgba(0, 123, 255, 0.4)"}, {label: "My Second dataset", data: [28, 12, 40, 19, 63, 27, 87], borderColor: "rgba(0, 123, 255, 0.7", borderWidth: "1", backgroundColor: "rgba(0, 123, 255, 0.5)"}]}, options: {legend: {position: 'top'}, scale: {ticks: {beginAtZero: true}}}});
    var ctx = document.getElementById("pieChart");
    ctx.height = 300;
    var myChart = new Chart(ctx, {type: 'pie', data: {datasets: [{data: [45, 25, 20, 10], backgroundColor: ["rgba(0, 123, 255,0.9)", "rgba(0, 123, 255,0.7)", "rgba(0, 123, 255,0.5)", "rgba(0,0,0,0.07)"], hoverBackgroundColor: ["rgba(0, 123, 255,0.9)", "rgba(0, 123, 255,0.7)", "rgba(0, 123, 255,0.5)", "rgba(0,0,0,0.07)"]}], labels: ["green", "green", "green"]}, options: {responsive: true}});
    var ctx = document.getElementById("doughutChart");
    ctx.height = 150;
    var myChart = new Chart(ctx, {type: 'doughnut', data: {datasets: [{data: [45, 25, 20, 10], backgroundColor: ["rgba(0, 123, 255,0.9)", "rgba(0, 123, 255,0.7)", "rgba(0, 123, 255,0.5)", "rgba(0,0,0,0.07)"], hoverBackgroundColor: ["rgba(0, 123, 255,0.9)", "rgba(0, 123, 255,0.7)", "rgba(0, 123, 255,0.5)", "rgba(0,0,0,0.07)"]}], labels: ["green", "green", "green", "green"]}, options: {responsive: true}});
    var ctx = document.getElementById("polarChart");
    ctx.height = 150;
    var myChart = new Chart(ctx, {type: 'polarArea', data: {datasets: [{data: [15, 18, 9, 6, 19], backgroundColor: ["rgba(0, 123, 255,0.9)", "rgba(0, 123, 255,0.8)", "rgba(0, 123, 255,0.7)", "rgba(0,0,0,0.2)", "rgba(0, 123, 255,0.5)"]}], labels: ["green", "green", "green", "green"]}, options: {responsive: true}});
    var ctx = document.getElementById("singelBarChart");
    ctx.height = 150;
    var myChart = new Chart(ctx, {type: 'bar', data: {labels: ["Sun", "Mon", "Tu", "Wed", "Th", "Fri", "Sat"], datasets: [{label: "My First dataset", data: [40, 55, 75, 81, 56, 55, 40], borderColor: "rgba(0, 123, 255, 0.9)", borderWidth: "0", backgroundColor: "rgba(0, 123, 255, 0.5)"}]}, options: {scales: {yAxes: [{ticks: {beginAtZero: true}}]}}});
})(jQuery);
