/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

var mDefaultDataTableInstance;
var sampleTable;


$(document).ready(function () {
    initTable();
    sampleTable = $('#myTable').DataTable(mDefaultDataTableInstance);
    filtrarEmpleados(0);
    $('#myTable tbody').on('click', 'tr', function () {
        const row = sampleTable.row(this).data();
        detalles(row[0]);
        $('#myTable tbody tr').removeClass('table-info');
        $(this).addClass('table-info');
    });
    validation();

});

function initTable() {
    mDefaultDataTableInstance = {
        "pageLength": 10,
        "bLengthChange": true,
        "bFilter": true,
        "bProcessing": true,
        "pagingType": "full_numbers",
        "ordering": false,
        "oLanguage":
                {
                    "sProcessing": "Procesando...",
                    "sLengthMenu": "Mostrar _MENU_ registros",
                    "sZeroRecords": "No se encontraron resultados",
                    "sEmptyTable": "Ningún dato disponible en esta tabla",
                    "sInfo": "Mostrando registros del _START_ al _END_ de un total de _TOTAL_ registros",
                    "sInfoEmpty": "Mostrando registros del 0 al 0 de un total de 0 registros",
                    "sInfoFiltered": "(filtrado de un total de _MAX_ registros)",
                    "sInfoPostFix": "",
                    "sSearch": "Buscar:",
                    "sUrl": "",
                    "sInfoThousands": ",",
                    "sLoadingRecords": "Cargando...",
                    "oPaginate": {
                        "sFirst": '<i class="fa fa-angle-double-left"></i>', // This is the link to the first page
                        "sPrevious": '<i class="fa fa-angle-left"></i>', // This is the link to the previous page
                        "sNext": '<i class="fa fa-angle-right"></i>', // This is the link to the next page
                        "sLast": '<i class="fa fa-angle-double-right"></i>' // This is the link to the last page
                    }
                },
        "rowCallback": function (row, data, index) {
            $('td', row).eq(0).addClass('text-center nowrap d-none');
            $('td', row).eq(1).addClass('text-center nowrap');
            $('td', row).eq(2).addClass('text-center nowrap');
            $('td', row).eq(3).addClass('text-center nowrap');
        }
    };
}

var validation = function () {
    $('#myform').validate({
        lang: 'es',
        rules: {
            'nombres': {
                required: true,
                minlength: 3,
                maxlength: 200
            },
            'apellidos': {
                required: true,
                minlength: 3,
                maxlength: 200
            },
            'correo': {
                required: true
            },
            'dni': {
                required: true
            }
        },
        highlight: function (element) {
            $(element).closest('.form-group').addClass('has-error');
        },
        unhighlight: function (element) {
            $(element).closest('.form-group').removeClass('has-error');
        },
        errorElement: 'span',
        errorClass: 'help-block',
        errorPlacement: function (error, element) {
            if (element.parent('.input-group').length) {
                error.insertAfter(element.parent());
            } else {
                error.insertAfter(element);
            }
        }
    });
};

var validateForm = function () {
    return $('#myform').valid();
};


function guardarEmpleado() {
    var formData = new FormData(document.getElementById("myform"));
    $.ajax({
        beforeSend: function (jqXHR) {
            $("#spinner").show();
            $("#spinner button").unbind("click");
            $("#spinner button").click(function () {
                jqXHR.abort();
                $("#spinner").hide();
            });
        },
        url: 'subirfile',
        type: 'POST',
        data: formData,
        async: false,
        cache: false,
        contentType: false,
        processData: false,
        dataType: "json",
        success: function (data) {
            if (data === "success") {
                $.notify({
                    title: "Sistema Ok: ",
                    message: "Registro Insertado!"
                }, {
                    type: "success"
                });
            } else {
                $.notify({
                    title: "Sistema Error: ",
                    message: "Registro fallido!"
                }, {
                    type: "danger"
                });
            }
            filtrarEmpleados(1);
        },
        complete: function () {
            $("#spinner").hide();
        }
    });
}

function EliminarEmpleado() {
    $.ajax({
        url: 'eliminarEmpleado',
        type: 'POST',
        data: {
            idempleado: $("#idempleado").val()
        },
        dataType: "json",
        beforeSend: function (jqXHR) {
            $("#spinner").show();
            $("#spinner button").unbind("click");
            $("#spinner button").click(function () {
                jqXHR.abort();
                $("#spinner").hide();
            });
        },
        success: function (data) {
            if (data === "success") {
                $.notify({
                    title: "Sistema Ok: ",
                    message: "Registro Eliminado!"
                }, {
                    type: "success"
                });
            } else {
                $.notify({
                    title: "Sistema Error: ",
                    message: "Registro fallido!"
                }, {
                    type: "danger"
                });
            }

        },
        complete: function () {
            $("#spinner").hide();
            filtrarEmpleados(1);
        }
    });
}

var validateForm = function () {
    return $('#myform').valid();
};

var filtrarEmpleados = function (parametro) {
    if (parametro == "1") {
        cleanEmpleado();
    }
    $.ajax({
        url: 'documentos_filtrar',
        type: 'POST',
        dataType: "json",
        beforeSend: function (jqXHR) {
            $("#spinner").show();
            $("#spinner button").unbind("click");
            $("#spinner button").click(function () {
                jqXHR.abort();
                $("#spinner").hide();
            });
        },
        success: function (data) {
            listar(data);
        },
        complete: function () {
            $("#spinner").hide();
        }
    });
    $("#botonLimpiar").css("display", "inline");
    $("#botonCancelar").css("display", "none");
    $("#botonEliminar").css("display", "none");

};

var detalles = function (id) {
    $.ajax({
        url: 'documentos_filtrar',
        type: 'POST',
        dataType: "json",
        beforeSend: function (jqXHR) {
            $("#spinner").show();
            $("#spinner button").unbind("click");
            $("#spinner button").click(function () {
                jqXHR.abort();
                $("#spinner").hide();
            });
        },
        data: {
            id: id
        },
        success: function (data) {
            $("#id").val(data[0]['id']);
            $("#tipo").val(data[0]['tipo']);
            $("#titulo").val(data[0]['titulo']);
        },
        error: function (XMLHttpRequest, textStatus, errorThrown) {
            ajaxError(XMLHttpRequest, textStatus, errorThrown);
        },
        complete: function () {
            $("#spinner").hide();
        }
    });
};

var cleanEmpleado = function () {
    $("#id").val("");
    $("#titulo").val("");
    $("#nombre").val("");
    $("#file").val("");
};

var listar = function (data) {
    sampleTable.clear();
    $.each(data, function (i, items) {
        sampleTable.row.add([
            items['id'],
            items['tipo'],
            items['titulo'],
            items['pdf'],
            "<a href='eliminar/"+items['id']+"'>eliminar</a>"
        ]).draw();
    });
};

