/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

var mDefaultDataTableInstance;
var sampleTable;


$(document).ready(function () {
    initTable();
    sampleTable = $('#myTable').DataTable(mDefaultDataTableInstance);
    filtrarEmpleados(0);
    $('#myTable tbody').on('click', 'tr', function () {
        detalles($($(this).find("input")[0]).val());
        $('#myTable tbody tr').removeClass('table-info');
        $(this).addClass('table-info');
    });
    validation();

});

function initTable() {
    mDefaultDataTableInstance = {
        dom: 'Bfrtip',
        "pageLength": 10,
        "bLengthChange": true,
        "bFilter": true,
        "bProcessing": true,
        "pagingType": "full_numbers",
        "ordering": false,
        "oLanguage": {
            "sInfo": 'Nro de Registro: _START_ a _END_ de _TOTAL_',
            "sInfoEmpty": 'Hay un total de _TOTAL_ registros',
            "sEmptyTable": 'No hay registros para mostrar',
            "sZeroRecords": 'There are no matching <span class="lvllbl"></span>(s) to display',
            "sProcessing": 'Cargando',
            "oPaginate": {
                "sFirst": '<i class="fa fa-angle-double-left"></i>', // This is the link to the first page
                "sPrevious": '<i class="fa fa-angle-left"></i>', // This is the link to the previous page
                "sNext": '<i class="fa fa-angle-right"></i>', // This is the link to the next page
                "sLast": '<i class="fa fa-angle-double-right"></i>' // This is the link to the last page
            }
        },
        "rowCallback": function (row, data, index) {
            $('td', row).eq(0).addClass('text-center nowrap');
            $('td', row).eq(1).addClass('text-center nowrap');
            $('td', row).eq(2).addClass('text-center nowrap');
            $('td', row).eq(3).addClass('text-center nowrap');
            $('td', row).eq(4).addClass('text-center nowrap');
            $('td', row).eq(5).addClass('text-center nowrap');
            if (data[6] == "1") {
                $('td', row).eq(6).html('Activo');
            } else {
                $('td', row).eq(6).html('Inactivo');
            }
            $('td', row).eq(0).html("<input id='idempleadoList' name='idempleadoList' type='hidden' value='" + data[7] + "'/>" + data[0] + "");
        },
        buttons: [
            'copyHtml5', 'excelHtml5', 'pdfHtml5', 'csvHtml5'
        ]
    };
}

var validation = function () {
    $('#myform').validate({
        lang: 'es',
        rules: {
            'nombres': {
                required: true,
                minlength: 3,
                maxlength: 200
            },
            'apellidos': {
                required: true,
                minlength: 3,
                maxlength: 200
            },
            'correo': {
                required: true
            },
            'dni': {
                required: true
            }
        },
        highlight: function (element) {
            $(element).closest('.form-group').addClass('has-error');
        },
        unhighlight: function (element) {
            $(element).closest('.form-group').removeClass('has-error');
        },
        errorElement: 'span',
        errorClass: 'help-block',
        errorPlacement: function (error, element) {
            if (element.parent('.input-group').length) {
                error.insertAfter(element.parent());
            } else {
                error.insertAfter(element);
            }
        }
    });
};

var validateForm = function () {
    return $('#myform').valid();
};


function guardarEmpleado() {
    if (validateForm()) {
        $.ajax({
            url: 'insertarEmpleado',
            type: 'POST',
            data: {
                nombres: $("#nombres").val(),
                apellidos: $("#apellidos").val(),
                idempleado: $("#idempleado").val(),
                correo: $("#correo").val(),
                telefono: $("#telefono").val(),
                dni: $("#dni").val(),
                idempresa: $("#idempresa").val(),
                fecha_nac: $("#fecha_nac").val(),
                estado: $("#estado").val()
            },
            dataType: "json",
            beforeSend: function (jqXHR) {
                $("#spinner").show();
                $("#spinner button").unbind("click");
                $("#spinner button").click(function () {
                    jqXHR.abort();
                    $("#spinner").hide();
                });
            },
            success: function (data) {
                if (data === "success") {
                    $.notify({
                        title: "Sistema Ok: ",
                        message: "Registro Insertado!"
                    }, {
                        type: "success"
                    });

                    filtrarEmpleados(1);
                } else {
                    $.notify({
                        title: "Sistema Ok: ",
                        message: "Error Insertado!"
                    }, {
                        type: "danger"
                    });
                }

            },
            complete: function () {
                $("#spinner").hide();
            }
        });
    }
}

function EliminarEmpleado() {
    $.ajax({
        url: 'eliminarEmpleado',
        type: 'POST',
        data: {
            idempleado: $("#idempleado").val()
        },
        dataType: "json",
        beforeSend: function (jqXHR) {
            $("#spinner").show();
            $("#spinner button").unbind("click");
            $("#spinner button").click(function () {
                jqXHR.abort();
                $("#spinner").hide();
            });
        },
        success: function (data) {
            if (data === "success") {
                $.notify({
                    title: "Sistema Ok: ",
                    message: "Registro Eliminado!"
                }, {
                    type: "success"
                });
            } else {
                $.notify({
                    title: "Sistema Error: ",
                    message: "Registro fallido!"
                }, {
                    type: "danger"
                });
            }

        },
        complete: function () {
            $("#spinner").hide();
            filtrarEmpleados(1);
        }
    });
}

var validateForm = function () {
    return $('#myform').valid();
};

var filtrarEmpleados = function (parametro) {
    if (parametro == "1") {
        cleanEmpleado();
    }
    $.ajax({
        url: 'filtroEmpleado',
        type: 'POST',
        dataType: "json",
        beforeSend: function (jqXHR) {
            $("#spinner").show();
            $("#spinner button").unbind("click");
            $("#spinner button").click(function () {
                jqXHR.abort();
                $("#spinner").hide();
            });
        },
        success: function (data) {
            listadoEmpleados(data);
        },
        complete: function () {
            $("#spinner").hide();
        }
    });
    $("#botonLimpiar").css("display", "inline");
    $("#botonCancelar").css("display", "none");
    $("#botonEliminar").css("display", "none");

};

var detalles = function (id) {
    $.ajax({
        url: 'filtroEmpleado',
        type: 'POST',
        dataType: "json",
        beforeSend: function (jqXHR) {
            $("#spinner").show();
            $("#spinner button").unbind("click");
            $("#spinner button").click(function () {
                jqXHR.abort();
                $("#spinner").hide();
            });
        },
        data: {
            idempleado: id
        },
        success: function (data) {
            $("#idempleado").val(data[0]['idempleado']);
            $("#nombres").val(data[0]['nombres']);
            $("#apellidos").val(data[0]['apellidos']);
            $("#correo").val(data[0]['correo']);
            $("#telefono").val(data[0]['telefono']);
            $("#dni").val(data[0]['dni']);
            $("#idempresa").val(data[0]['idempresa']);
            $("#fecha_nac").val(data[0]['fecha_nac']);
            $("#estado").val(data[0]['estado']);
        },
        error: function (XMLHttpRequest, textStatus, errorThrown) {
            ajaxError(XMLHttpRequest, textStatus, errorThrown);
        },
        complete: function () {
            $("#spinner").hide();
        }
    });
};

var cleanEmpleado = function () {
    $("#idempleado").val("");
    $("#nombres").val("");
    $("#apellidos").val("");
    $("#dni").val("");
    $("#correo").val("");
    $("#telefono").val("");
    $("#fecha_nac").val("");
    $("#idempresa").val("");
    $("#estado").val("");
};

var listadoEmpleados = function (data) {
    sampleTable.clear();
    $.each(data, function (i, items) {
        sampleTable.row.add([
            items['dni'],
            items['nombres'],
            items['apellidos'],
            items['correo'],
            items['telefono'],
            items['empresa'],
            items['estado'],
            items['idempleado']
        ]).draw();
    });
};

