/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

var mDefaultDataTableInstance;
var sampleTable;


$(document).ready(function () {
    initTable();
    sampleTable = $('#myTable').DataTable(mDefaultDataTableInstance);
    filtrarEmpresas(0);
    $('#myTable tbody').on('click', 'tr', function () {
        detalles($($(this).find("input")[0]).val());
        $('#myTable tbody tr').removeClass('table-info');
        $(this).addClass('table-info');
    });
    validation();

});

function initTable() {
    mDefaultDataTableInstance = {
        "pageLength": 10,
        "bLengthChange": true,
        "bFilter": true,
        "bProcessing": true,
        "pagingType": "full_numbers",
        "ordering": false,
        "oLanguage": {
            "sInfo": 'Nro de Registro: _START_ a _END_ de _TOTAL_',
            "sInfoEmpty": 'Hay un total de _TOTAL_ registros',
            "sEmptyTable": 'No hay registros para mostrar',
            "sZeroRecords": 'There are no matching <span class="lvllbl"></span>(s) to display',
            "sProcessing": 'Cargando',
            "oPaginate": {
                "sFirst": '<i class="fa fa-angle-double-left"></i>', // This is the link to the first page
                "sPrevious": '<i class="fa fa-angle-left"></i>', // This is the link to the previous page
                "sNext": '<i class="fa fa-angle-right"></i>', // This is the link to the next page
                "sLast": '<i class="fa fa-angle-double-right"></i>' // This is the link to the last page
            }
        },
        "rowCallback": function (row, data, index) {
            $('td', row).eq(0).addClass('text-center nowrap');
            $('td', row).eq(1).addClass('text-center nowrap');
            $('td', row).eq(2).addClass('text-center nowrap');
            $('td', row).eq(3).addClass('text-center nowrap');
            $('td', row).eq(4).addClass('text-center nowrap');
            $('td', row).eq(5).addClass('text-center nowrap');
            if (data[2] == "1") {
                $('td', row).eq(2).html('Activo');
            } else {
                $('td', row).eq(2).html('Inactivo');
            }
            $('td', row).eq(0).html("<input id='idempresaList' name='idempresaList' type='hidden' value='" + data[3] + "'/>" + data[0] + "");
        }
    };
}

var validation = function () {
    $('#myform').validate({
        lang: 'es',
        rules: {
            'razon_social': {
                required: true,
                minlength: 3,
                maxlength: 200
            },
            'ruc_empresa': {
                required: true
            }
        },
        highlight: function (element) {
            $(element).closest('.form-group').addClass('has-error');
        },
        unhighlight: function (element) {
            $(element).closest('.form-group').removeClass('has-error');
        },
        errorElement: 'span',
        errorClass: 'help-block',
        errorPlacement: function (error, element) {
            if (element.parent('.input-group').length) {
                error.insertAfter(element.parent());
            } else {
                error.insertAfter(element);
            }
        }
    });
};

var validateForm = function () {
    return $('#myform').valid();
};


function guardarEmpresa() {
    if (validateForm()) {
        $.ajax({
            url: 'insertarEmpresa',
            type: 'POST',
            data: {
                razon_social: $("#razon_social").val(),
                idempresa: $("#idempresa").val(),
                ruc_empresa: $("#ruc_empresa").val(),
                estado: $("#estado").val()
            },
            dataType: "json",
            beforeSend: function (jqXHR) {
                $("#spinner").show();
                $("#spinner button").unbind("click");
                $("#spinner button").click(function () {
                    jqXHR.abort();
                    $("#spinner").hide();
                });
            },
            success: function (data) {
                if (data === "success") {
                    $.notify({
                        title: "Sistema Ok: ",
                        message: "Registro Insertado!"
                    }, {
                        type: "success"
                    });

                    filtrarEmpresas(1);
                } else {
                    $.notify({
                        title: "Sistema Ok: ",
                        message: "Error Insertado!"
                    }, {
                        type: "danger"
                    });
                }

            },
            complete: function () {
                $("#spinner").hide();
            }
        });
    }
}

function EliminarEmpresa() {
    $.ajax({
        url: 'eliminarEmpresa',
        type: 'POST',
        data: {
            idempresa: $("#idempresa").val()
        },
        dataType: "json",
        beforeSend: function (jqXHR) {
            $("#spinner").show();
            $("#spinner button").unbind("click");
            $("#spinner button").click(function () {
                jqXHR.abort();
                $("#spinner").hide();
            });
        },
        success: function (data) {
            if (data === "success") {
                $.notify({
                    title: "Sistema Ok: ",
                    message: "Registro Eliminado!"
                }, {
                    type: "success"
                });
            } else {
                $.notify({
                    title: "Sistema Error: ",
                    message: "Registro fallido!"
                }, {
                    type: "danger"
                });
            }

        },
        complete: function () {
            $("#spinner").hide();
            filtrarEmpresas(1);
        }
    });
}

var validateForm = function () {
    return $('#myform').valid();
};

var filtrarEmpresas = function (parametro) {
    if (parametro == "1") {
        cleanEmpresa();
    }
    $.ajax({
        url: 'filtroEmpresa',
        type: 'POST',
        dataType: "json",
        beforeSend: function (jqXHR) {
            $("#spinner").show();
            $("#spinner button").unbind("click");
            $("#spinner button").click(function () {
                jqXHR.abort();
                $("#spinner").hide();
            });
        },
        success: function (data) {
            listadoEmpresas(data);
        },
        complete: function () {
            $("#spinner").hide();
        }
    });
    $("#botonLimpiar").css("display", "inline");
    $("#botonCancelar").css("display", "none");
    $("#botonEliminar").css("display", "none");

};

var detalles = function (id) {
    $.ajax({
        url: 'filtroEmpresa',
        type: 'POST',
        dataType: "json",
        beforeSend: function (jqXHR) {
            $("#spinner").show();
            $("#spinner button").unbind("click");
            $("#spinner button").click(function () {
                jqXHR.abort();
                $("#spinner").hide();
            });
        },
        data: {
            idempresa: id
        },
        success: function (data) {
            $("#idempresa").val(data[0]['idempresa']);
            $("#razon_social").val(data[0]['razon_social']);
            $("#ruc_empresa").val(data[0]['ruc_empresa']);
            $("#estado").val(data[0]['estado']);
        },
        error: function (XMLHttpRequest, textStatus, errorThrown) {
            ajaxError(XMLHttpRequest, textStatus, errorThrown);
        },
        complete: function () {
            $("#spinner").hide();
        }
    });
};

var cleanEmpresa = function () {
    $("#idempresa").val("");
    $("#razon_social").val("");
    $("#ruc_empresa").val("");
    $("#estado").val("");
};

var listadoEmpresas = function (data) {
    sampleTable.clear();
    $.each(data, function (i, items) {
        sampleTable.row.add([
            items['ruc_empresa'],
            items['razon_social'],
            items['estado'],
            items['idempresa']
        ]).draw();
    });
};

