$(document).ready(function () {
    initTable();
    sampleTable = $('#myTable').DataTable(mDefaultDataTableInstance);
//    filtrar(); 
});

function filtrar() {
    $.ajax({
        url: '/control/reportes/filtrarFob',
        type: 'POST',
        data: {
            annio: $("#annio").val()
        },
        dataType: "json",
        beforeSend: function (jqXHR) {
            $("#spinner").show();
            $("#spinner button").unbind("click");
            $("#spinner button").click(function () {
                jqXHR.abort();
                $("#spinner").hide();
            });
        },
        success: function (array) {
            listadoPaquete(array['data']);

        },
        complete: function () {
            $("#spinner").hide();
        }
    });
}

var listadoPaquete = function (data) {

    sampleTable.clear().rows.add(data).draw();
};


function initTable() {
    mDefaultDataTableInstance = {
        "dom": 'Bfrtip',
        "pageLength": 10,
        "bLengthChange": true,
        "bFilter": true,
        "ordering": false,
        "scrollX": true,
        "scrollCollapse": true,
        "bProcessing": true,
        "pagingType": "full_numbers",
        buttons: [
            'copy', 'csv', 'excel', 'pdf', 'print'
        ],
        "oLanguage": {
            "sInfo": 'Nro de Registro: _START_ a _END_ de _TOTAL_',
            "sInfoEmpty": 'Hay un total de _TOTAL_ registros',
            "sEmptyTable": 'No hay registros para mostrar',
            "sZeroRecords": 'There are no matching <span class="lvllbl"></span>(s) to display',
            "sProcessing": 'Cargando',
            "oPaginate": {
                "sFirst": '<i class="fa fa-angle-double-left"></i>', // This is the link to the first page
                "sPrevious": '<i class="fa fa-angle-left"></i>', // This is the link to the previous page
                "sNext": '<i class="fa fa-angle-right"></i>', // This is the link to the next page
                "sLast": '<i class="fa fa-angle-double-right"></i>' // This is the link to the last page
            }
        },
        "rowCallback": function (row, data, index) {
            $('td', row).eq(0).addClass('nowrap');
            var url = "/control/reportes/impoDetallado/" + data['ANNIO'];
            var url2 = "/control/reportes/totalDetallado/" + data['ANNIO'];
            var url3 = "/control/reportes/expoDetallado/" + data['ANNIO'];
            $('td', row).eq(1).html("<a style='color: blue' href='" + url2 + "'>" + data['TOTAL'] + "</a>");
            $('td', row).eq(2).html("<a  style='color: blue' href='" + url + "'>" + data['IMPO'] + "</a>");
            $('td', row).eq(3).html("<a style='color: blue' href='" + url3 + "'>" + data['EXPO'] + "</a>");
        }
    };
}

function ImpoDetallado() {
    var annio = $("#annio").val();
    window.location.href = "/control/reportes/impoDetallado/" + annio;

}


function ExpoDetallado() {
    var annio = $("#annio").val();
    window.location.href = "/control/reportes/expoDetallado/" + annio;
}

function ExpoOtros() {
    var annio = $("#annio").val();
    window.location.href = "/control/reportes/otrosDetallado/" + annio;
}

