/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

var mDefaultDataTableInstance;
var sampleTable;


$(document).ready(function () {
    initTable();
    sampleTable = $('#myTable').DataTable(mDefaultDataTableInstance);
    filtrarSubProceso(0);

});

function initTable() {
    mDefaultDataTableInstance = {
        "pageLength": 10,
        "bLengthChange": true,
        "bFilter": true,
        "bProcessing": true,
        "pagingType": "full_numbers",
        "ordering": false,
        "oLanguage": {
            "sInfo": 'Nro de Registro: _START_ a _END_ de _TOTAL_',
            "sInfoEmpty": 'Hay un total de _TOTAL_ registros',
            "sEmptyTable": 'No hay registros para mostrar',
            "sZeroRecords": 'There are no matching <span class="lvllbl"></span>(s) to display',
            "sProcessing": 'Cargando',
            "oPaginate": {
                "sFirst": '<i class="fa fa-angle-double-left"></i>', // This is the link to the first page
                "sPrevious": '<i class="fa fa-angle-left"></i>', // This is the link to the previous page
                "sNext": '<i class="fa fa-angle-right"></i>', // This is the link to the next page
                "sLast": '<i class="fa fa-angle-double-right"></i>' // This is the link to the last page
            }
        },
        "rowCallback": function (row, data, index) {
            $('td', row).eq(0).addClass('text-center nowrap');
            $('td', row).eq(1).addClass('text-center nowrap');
            $('td', row).eq(2).addClass('text-center nowrap');
            var url = "/control/files/" + data[2] + ".pdf";
            if (doesFileExist(url)) {
                $('td', row).eq(2).html("<a href='" + url + "' target='_blank'>Ver</a>");
            } else {
                $('td', row).eq(2).html("Sin Archivo");
            }
        }
    };
}

function doesFileExist(urlToFile) {
    var xhr = new XMLHttpRequest();
    xhr.open('HEAD', urlToFile, false);
    xhr.send();

    if (xhr.status == "404") {
        return false;
    } else {
        return true;
    }
}

var filtrarSubProceso = function (parametro) {
    if (parametro == "1") {
        cleanSubProceso();
    }
    $.ajax({
        url: '/control/home/filtroSubProceso',
        type: 'POST',
        dataType: "json",
        data: {
            idsubproceso: $("#idsubproceso").val(),
	    tipo: $("#tipo").val()
        },
        beforeSend: function (jqXHR) {
            $("#spinner").show();
            $("#spinner button").unbind("click");
            $("#spinner button").click(function () {
                jqXHR.abort();
                $("#spinner").hide();
            });
        },
        success: function (data) {
            listadoSubProceso(data['subproceso']);
        },
        complete: function () {
            $("#spinner").hide();
        }
    });
    $("#botonLimpiar").css("display", "inline");
    $("#botonCancelar").css("display", "none");
    $("#botonEliminar").css("display", "none");

};

var listadoSubProceso = function (data) {
    sampleTable.clear();
    var contador = 1;
    $.each(data, function (i, items) {
        sampleTable.row.add([
            contador,
            items['descripcion'],
            items['idsubproceso']
        ]).draw();
        contador++;
    });
};

