$(document).ready(function () {
    initTable();
    sampleTable = $('#myTable').DataTable(mDefaultDataTableInstance);
//    filtrar(); 
});

function filtrar() {
    $.ajax({
        url: '/control/reportes/filtrarAnnio',
        type: 'POST',
        data: {
            annio: $("#annio").val(),
            mes: $("#mes").val(),
            CODI_CLTE: $("#CODI_CLTE").val()
        },
        dataType: "json",
        beforeSend: function (jqXHR) {
            $("#spinner").show();
            $("#spinner button").unbind("click");
            $("#spinner button").click(function () {
                jqXHR.abort();
                $("#spinner").hide();
            });
        },
        success: function (array) {
            listadoPaquete(array['data']);
            removeadd();
	    var total = 0;
	    var i;
	    for(i=0; i<array['descarga'].length; i++){
		total = total + parseInt(array['descarga'][i]);
	    }
	    $("#total").html(total);
            var ctx = document.getElementById("singelBarChart");
            ctx.height = 150;
            var myChart = new Chart(ctx, {
                type: 'bar',
                data: {
                    labels: array['mes'],
                    datasets: [
                        {
                            label: "DAMS Por Mes",
                            data: array['descarga'],
                            borderColor: "rgba(0, 123, 255, 0.9)",
                            borderWidth: "0",
                            backgroundColor: "rgba(0, 123, 255, 0.5)"
                        },
                        {
                            label: "Verde", 
                            data: array['descargaLima'],
                            borderColor: "rgba(0,255,0,0.2)",
                            borderWidth: "0",
                            backgroundColor: "rgba(0,255,0,0.2)"
                        },
                        {
                            label: "Naranja", 
                            data: array['descargaDesahuadero'],
                            borderColor: "rgba(255, 128, 0, 1.0)",
                            borderWidth: "0",
                            backgroundColor: "rgba(255, 128, 0, 1.0)"
                        },
                        {
                            label: "Rojo", 
                            data: array['descargaPisco'],
                            borderColor: "rgba(255,0,0,1)",
                            borderWidth: "0",
                            backgroundColor: "rgba(255,0,0,1)"
                        }
                        
                    ]
                },
                options: { 
                    scales: {
                        yAxes: [{
                                ticks: {
                                    beginAtZero: true
                                }
                            }]
                    }
                }
            });

        },
        complete: function () {
            $("#spinner").hide();
        }
    });
}


function removeadd() {
    $("#card").html("");
    $("#card").html("<h4 class='mb-3'>Dams Mensual Total: <span style='font-weight: bold' id='total'></span> </h4><canvas id='singelBarChart'></canvas>");
}

var listadoPaquete = function (data) {
    
    sampleTable.clear().rows.add(data).draw();
};


function initTable() {
    mDefaultDataTableInstance = {
        "dom": 'Bfrtip',
        "pageLength": 10,
        "bLengthChange": true,
        "bFilter": true,
        "ordering": false,
        "scrollX": true,
        "scrollCollapse": true,
        "bProcessing": true,
        "pagingType": "full_numbers",
        buttons: [
            'copy', 'csv', 'excel', 'pdf', 'print'
        ],
        "oLanguage": {
            "sInfo": 'Nro de Registro: _START_ a _END_ de _TOTAL_',
            "sInfoEmpty": 'Hay un total de _TOTAL_ registros',
            "sEmptyTable": 'No hay registros para mostrar',
            "sZeroRecords": 'There are no matching <span class="lvllbl"></span>(s) to display',
            "sProcessing": 'Cargando',
            "oPaginate": {
                "sFirst": '<i class="fa fa-angle-double-left"></i>', // This is the link to the first page
                "sPrevious": '<i class="fa fa-angle-left"></i>', // This is the link to the previous page
                "sNext": '<i class="fa fa-angle-right"></i>', // This is the link to the next page
                "sLast": '<i class="fa fa-angle-double-right"></i>' // This is the link to the last page
            }
        },
        "rowCallback": function (row, data, index) {
            $('td', row).eq(0).addClass('nowrap');
            $('td', row).eq(1).addClass('nowrap');
            $('td', row).eq(2).addClass('nowrap');
            $('td', row).eq(3).addClass('nowrap');
            $('td', row).eq(4).addClass('nowrap');
            $('td', row).eq(5).addClass('nowrap');
            $('td', row).eq(6).addClass('nowrap');
            $('td', row).eq(7).addClass('nowrap');
            $('td', row).eq(8).addClass('nowrap');
            $('td', row).eq(9).addClass('nowrap');
            $('td', row).eq(10).addClass('nowrap');
            $('td', row).eq(11).addClass('nowrap');
            $('td', row).eq(12).addClass('nowrap');
            $('td', row).eq(13).addClass('nowrap');
            $('td', row).eq(14).addClass('nowrap');
            $('td', row).eq(15).addClass('nowrap');
            $('td', row).eq(16).addClass('nowrap');
            $('td', row).eq(17).addClass('nowrap');
            $('td', row).eq(18).addClass('nowrap');
            $('td', row).eq(19).addClass('nowrap');
            $('td', row).eq(20).addClass('nowrap');
            $('td', row).eq(21).addClass('nowrap');
        }
    };
}

