/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

var mDefaultDataTableInstance;
var sampleTable;


$(document).ready(function () {
    initTable();
    sampleTable = $('#myTable').DataTable(mDefaultDataTableInstance);
    filtrarCourier();
});

function initTable() {
    mDefaultDataTableInstance = {
        "pageLength": 10,
        "bLengthChange": true,
        "bFilter": true,
        "bProcessing": true,
        "pagingType": "full_numbers",
        "ordering": false,
        "oLanguage": {
            "sInfo": 'Nro de Registro: _START_ a _END_ de _TOTAL_',
            "sInfoEmpty": 'Hay un total de _TOTAL_ registros',
            "sEmptyTable": 'No hay registros para mostrar',
            "sZeroRecords": 'There are no matching <span class="lvllbl"></span>(s) to display',
            "sProcessing": 'Cargando',
            "oPaginate": {
                "sFirst": '<i class="fa fa-angle-double-left"></i>', // This is the link to the first page
                "sPrevious": '<i class="fa fa-angle-left"></i>', // This is the link to the previous page
                "sNext": '<i class="fa fa-angle-right"></i>', // This is the link to the next page
                "sLast": '<i class="fa fa-angle-double-right"></i>' // This is the link to the last page
            }
        },
        "rowCallback": function (row, data, index) {
            $('td', row).eq(0).addClass('text-center');
            $('td', row).eq(1).addClass('text-center');
            $('td', row).eq(2).addClass('text-center');
            $('td', row).eq(3).addClass('text-center');
            $('td', row).eq(4).addClass('text-center');
            $('td', row).eq(5).addClass('text-center');
            $('td', row).eq(6).addClass('text-center');
            $('td', row).eq(7).addClass('text-center');
            $('td', row).eq(8).addClass('text-center');

            if (data[8] == "1") {
                $('td', row).eq(8).html('Pendiente');
            } else if (data[8] == "2") {
                $('td', row).eq(8).html("<a style='color: red' onclick='asignarMensajero(" + data[11] + ")' title='Cambio Estado' data-toggle='modal' data-target='#smallmodal'>Asignadas</a>");
            } else if (data[8] == "3") {
                $('td', row).eq(8).html('Entregada');
            } else if (data[8] == "4") {
                $('td', row).eq(8).html('Rechazada');
            } else if (data[8] == "5") {
                $('td', row).eq(8).html('Entregada por Recoger');
            } else if (data[8] == "6") {
                $('td', row).eq(8).html('Concluida');
            }
            
            
            $('td', row).eq(9).addClass('text-center');
            if (data[8] == "3" || data[8] == "4") {
                $('td', row).eq(11).html("<a onclick='cambioCoordenadas(" + data[12] + " , " + data[13] + ")' title='Ver Coordenadas'>ver coordenadas</a>");
            } else {
                $('td', row).eq(11).html("");
            }

        }
    };
}

function asignarMensajero(id) {
    $("#idcourierParameterDelete2").val(id);
}

var filtrarCourier = function () {
    $.ajax({
        url: '/control/courier/filtroMonitoreo',
        type: 'POST',
        dataType: "json",
        data: {
            fch_desde: $("#fch_desde").val(),
            fch_hasta: $("#fch_hasta").val(),
            estado: $("#estado").val()
        },
        beforeSend: function (jqXHR) {
            $("#spinner").show();
            $("#spinner button").unbind("click");
            $("#spinner button").click(function () {
                jqXHR.abort();
                $("#spinner").hide();
            });
        },
        success: function (data) {
            listadoCourier(data);
        },
        complete: function () {
            $("#spinner").hide();
        }
    });

};

function cambioEstado() {
    $.ajax({
        url: '/control/courier/CambioEstado',
        type: 'POST',
        dataType: "json",
        data: {
            estado: $("#estado2").val(),
            idcourier: $("#idcourierParameterDelete2").val()
        },
        beforeSend: function (jqXHR) {
            $("#spinner").show();
            $("#spinner button").unbind("click");
            $("#spinner button").click(function () {
                jqXHR.abort();
                $("#spinner").hide();
            });
        },
        success: function (data) {
            if (data === "success") {
                $.notify({
                    title: "Sistema Ok: ",
                    message: "Registro Asignado!"
                }, {
                    type: "success"
                });
            } else {
                $.notify({
                    title: "Sistema Error: ",
                    message: "Registro fallido!"
                }, {
                    type: "danger"
                });
            }
        },
        complete: function () {
            $("#spinner").hide();
            filtrarCourier();

        }
    });
}

function asignarOrdenCourier() {

    $.ajax({
        url: '/control/courier/asignarOrdenCourier',
        type: 'POST',
        dataType: "json",
        data: {
            idusuario_asignado: $("#idusuario_asignado").val(),
            idcourier: $("#idcourierParameterDelete").val(),
            prioridad: $("#prioridad").val()
        },
        beforeSend: function (jqXHR) {
            $("#spinner").show();
            $("#spinner button").unbind("click");
            $("#spinner button").click(function () {
                jqXHR.abort();
                $("#spinner").hide();
            });
        },
        success: function (data) {
            if (data === "success") {
                $.notify({
                    title: "Sistema Ok: ",
                    message: "Registro Asignado!"
                }, {
                    type: "success"
                });
            } else {
                $.notify({
                    title: "Sistema Error: ",
                    message: "Registro fallido!"
                }, {
                    type: "danger"
                });
            }
        },
        complete: function () {
            $("#spinner").hide();
            filtrarCourier();

        }
    });
}

var listadoCourier = function (data) {
     $("#myTable tbody tr").remove();
    sampleTable.clear();
    $.each(data, function (i, items) {
        sampleTable.row.add([
            items['annio'] + "-" + items['nro_orden'],
            items['fch_creacion'],
            items['usuario_crea'],
            items['cliente'],
            items['contacto'],
            items['telefono_contacto'],
            items['direccion'],
            items['usuario'],
            items['estado'],
            items['prioridad'],
            items['fch_entrega'],
            items['idcourier'],
            items['latitud'],
            items['longitud']
        ]).draw();
    });
};

function cambioCoordenadas(latitud, logintud) {
    var ubicacion = new google.maps.LatLng(latitud, logintud);

    var opcionesDeMapa = {
        zoom: 17,
        center: ubicacion,
        mapTypeId: google.maps.MapTypeId.ROADMAP //SATELITE, HYBRID, ROADMAP, TERRAIN
    };
    // instancia un nuevo objeto Map
    mapa = new google.maps.Map(document.getElementById("mapa"), opcionesDeMapa);
    // instancia un nuevo marcador ( la chincheta )
    var marker = new google.maps.Marker({
        position: ubicacion,
        map: mapa,
        title: "L& R Operadores"
    });
}
var mapa;
function initialize() {
    // las coordenadas de Barcelona		
    var ubicacion = new google.maps.LatLng(-12.0507414, -77.0890093);
    var opcionesDeMapa = {
        zoom: 17,
        center: ubicacion,
        mapTypeId: google.maps.MapTypeId.ROADMAP //SATELITE, HYBRID, ROADMAP, TERRAIN
    };
    // instancia un nuevo objeto Map
    mapa = new google.maps.Map(document.getElementById("mapa"), opcionesDeMapa);
    // instancia un nuevo marcador ( la chincheta )
    var marker = new google.maps.Marker({
        position: ubicacion,
        map: mapa,
        title: "L& R Operadores"
    });
}// acaba la funciÃ³n initialize
// inicializa el mapa cuando la ventana se haya cargado:
google.maps.event.addDomListener(window, "load", initialize);

