/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

var mDefaultDataTableInstance;
var sampleTable;


$(document).ready(function () {
    initTable();
    sampleTable = $('#myTable').DataTable(mDefaultDataTableInstance);
    filtrarMotivo(0);
    $('#myTable tbody').on('click', 'tr', function () {
        detalles($($(this).find("input")[0]).val());
        $('#myTable tbody tr').removeClass('table-info');
        $(this).addClass('table-info');
    });
    validation();

});

function initTable() {
    mDefaultDataTableInstance = {
        "pageLength": 10,
        "bLengthChange": true,
        "bFilter": true,
        "bProcessing": true,
        "pagingType": "full_numbers",
        "ordering": false,
        "oLanguage": {
            "sInfo": 'Nro de Registro: _START_ a _END_ de _TOTAL_',
            "sInfoEmpty": 'Hay un total de _TOTAL_ registros',
            "sEmptyTable": 'No hay registros para mostrar',
            "sZeroRecords": 'There are no matching <span class="lvllbl"></span>(s) to display',
            "sProcessing": 'Cargando',
            "oPaginate": {
                "sFirst": '<i class="fa fa-angle-double-left"></i>', // This is the link to the first page
                "sPrevious": '<i class="fa fa-angle-left"></i>', // This is the link to the previous page
                "sNext": '<i class="fa fa-angle-right"></i>', // This is the link to the next page
                "sLast": '<i class="fa fa-angle-double-right"></i>' // This is the link to the last page
            }
        },
        "rowCallback": function (row, data, index) {
            $('td', row).eq(0).addClass('text-center nowrap');
            $('td', row).eq(0).html("<input id='idmotivoList' name='idmotivoList' type='hidden' value='" + data[1] + "'/>" + data[0] + "");
        }
    };
}

var validation = function () {
    $('#myform').validate({
        lang: 'es',
        rules: {
            'descripcion': {
                required: true,
                minlength: 3,
                maxlength: 200
            }
        },
        highlight: function (element) {
            $(element).closest('.form-group').addClass('has-error');
        },
        unhighlight: function (element) {
            $(element).closest('.form-group').removeClass('has-error');
        },
        errorElement: 'span',
        errorClass: 'help-block',
        errorPlacement: function (error, element) {
            if (element.parent('.input-group').length) {
                error.insertAfter(element.parent());
            } else {
                error.insertAfter(element);
            }
        }
    });
};

var validateForm = function () {
    return $('#myform').valid();
};


function guardarMotivo() {
    if (validateForm()) {
        $.ajax({
            url: 'insertarMotivo',
            type: 'POST',
            data: {
                idmotivo: $("#idmotivo").val(),
                descripcion: $("#descripcion").val()
            },
            dataType: "json",
            beforeSend: function (jqXHR) {
                $("#spinner").show();
                $("#spinner button").unbind("click");
                $("#spinner button").click(function () {
                    jqXHR.abort();
                    $("#spinner").hide();
                });
            },
            success: function (data) {
                if (data === "success") {
                    $.notify({
                        title: "Sistema Ok: ",
                        message: "Registro Insertado!"
                    }, {
                        type: "success"
                    });

                    filtrarMotivo(1);
                } else {
                    $.notify({
                        title: "Error: ",
                        message: "Registro No Se Pudo Insertar!"
                    }, {
                        type: "danger"
                    });
                }

            },
            complete: function () {
                $("#spinner").hide();
            }
        });
    }
}

function EliminarMotivo() {
    $.ajax({
        url: 'eliminarMotivo',
        type: 'POST',
        data: {
            idmotivo: $("#idmotivo").val()
        },
        dataType: "json",
        beforeSend: function (jqXHR) {
            $("#spinner").show();
            $("#spinner button").unbind("click");
            $("#spinner button").click(function () {
                jqXHR.abort();
                $("#spinner").hide();
            });
        },
        success: function (data) {
            if (data === "success") {
                $.notify({
                    title: "Sistema Ok: ",
                    message: "Registro Eliminado!"
                }, {
                    type: "success"
                });
            } else {
                $.notify({
                    title: "Sistema Error: ",
                    message: "Registro fallido!"
                }, {
                    type: "danger"
                });
            }

        },
        complete: function () {
            $("#spinner").hide();
            filtrarMotivo(1);
        }
    });
}

var validateForm = function () {
    return $('#myform').valid();
};

var filtrarMotivo = function (parametro) {
    if (parametro == "1") {
        cleanMotivo();
    }
    $.ajax({
        url: 'filtroMotivo',
        type: 'POST',
        dataType: "json",
        beforeSend: function (jqXHR) {
            $("#spinner").show();
            $("#spinner button").unbind("click");
            $("#spinner button").click(function () {
                jqXHR.abort();
                $("#spinner").hide();
            });
        },
        success: function (data) {
            listadoMotivo(data);
        },
        complete: function () {
            $("#spinner").hide();
        }
    });
    $("#botonLimpiar").css("display", "inline");
    $("#botonCancelar").css("display", "none");
    $("#botonEliminar").css("display", "none");

};

var detalles = function (id) {
    $.ajax({
        url: 'filtroMotivo',
        type: 'POST',
        dataType: "json",
        beforeSend: function (jqXHR) {
            $("#spinner").show();
            $("#spinner button").unbind("click");
            $("#spinner button").click(function () {
                jqXHR.abort();
                $("#spinner").hide();
            });
        },
        data: {
            idmotivo: id
        },
        success: function (data) {
            $("#idmotivo").val(data[0]['idmotivo']);
            $("#descripcion").val(data[0]['descripcion']);
        },
        error: function (XMLHttpRequest, textStatus, errorThrown) {
            ajaxError(XMLHttpRequest, textStatus, errorThrown);
        },
        complete: function () {
            $("#spinner").hide();
        }
    });
};

var cleanMotivo = function () {
    $("#idmotivo").val("");
    $("#descripcion").val("");
};

var listadoMotivo = function (data) {
    sampleTable.clear();
    $.each(data, function (i, items) {
        sampleTable.row.add([
            items['descripcion'],
            items['idmotivo']
        ]).draw();
    });
};

