/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

$(document).ready(function () {
    validation();
});

var validation = function () {
    $('#myform').validate({
        lang: 'es',
        rules: {
            'hora_ingreso': {
                required: true,
                minlength: 3,
                maxlength: 200
            },
            'idempleado': {
                required: true
            }
        },
        highlight: function (element) {
            $(element).closest('.form-group').addClass('has-error');
        },
        unhighlight: function (element) {
            $(element).closest('.form-group').removeClass('has-error');
        },
        errorElement: 'span',
        errorClass: 'help-block',
        errorPlacement: function (error, element) {
            if (element.parent('.input-group').length) {
                error.insertAfter(element.parent());
            } else {
                error.insertAfter(element);
            }
        }
    });
};

var validateForm = function () {
    return $('#myform').valid();
};


function guardarAsistencia() {
    if (validateForm()) {
        $.ajax({
            url: '/control/asistencia/insertarAsistencia',
            type: 'POST',
            data: {
                idasistencia: $("#idasistencia").val(),
                fecha: formatF_YMD($("#fecha").val()),
                hora_ingreso: $("#hora_ingreso").val(),
                idempleado: $("#idempleado").val(),
                firma: $("#firma").val()
            },
            dataType: "json",
            beforeSend: function (jqXHR) {
                $("#spinner").show();
                $("#spinner button").unbind("click");
                $("#spinner button").click(function () {
                    jqXHR.abort();
                    $("#spinner").hide();
                });
            },
            success: function (data) {
                if (data === "success") {
                    $.notify({
                        title: "Sistema Ok: ",
                        message: "Registro Insertado!"
                    }, {
                        type: "success"
                    });
                } else if (data === "marca") {
                    $.notify({
                        title: "Alerta!",
                        message: "UD. Ya ingreso su marcación!"
                    }, {
                        type: "warning"
                    });
                } else {
                    $.notify({
                        title: "Sistema Ok: ",
                        message: "Error Insertado!"
                    }, {
                        type: "danger"
                    });
                }
            },
            complete: function () {
                $("#spinner").hide();
                cleanAsistencia();
            }
        });
    }
}

var cleanAsistencia = function () {
    $("#idasistencia").val("");
    $("#idempleado").val("");
    $('#idempleado_visita').trigger("chosen:updated");
    $("#firma").val("");
};

var formatF_YMD = function (fecha) {
    if (fecha != "") {
        var Finicial = "DD/MM/YYYY";
        var Ffinal = "YYYY-MM-DD";
        var fechanew = moment(fecha, Finicial);
        return fechanew.format(Ffinal);
    }
    return fecha;
};