/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

$(document).ready(function () {
    validation();
});

var validation = function () {
    $('#myform').validate({
        lang: 'es',
        rules: {
            'nombres_apellidos': {
                required: true,
                minlength: 3,
                maxlength: 200
            },
            'idmotivo': {
                required: true,
                minlength: 3,
                maxlength: 200
            },
            'nro_documento': {
                required: true
            }
        },
        highlight: function (element) {
            $(element).closest('.form-group').addClass('has-error');
        },
        unhighlight: function (element) {
            $(element).closest('.form-group').removeClass('has-error');
        },
        errorElement: 'span',
        errorClass: 'help-block',
        errorPlacement: function (error, element) {
            if (element.parent('.input-group').length) {
                error.insertAfter(element.parent());
            } else {
                error.insertAfter(element);
            }
        }
    });
};

var validateForm = function () {
    return $('#myform').valid();
};

function buscar() {
    if (validateForm()) {
        $.ajax({
            url: '/control/operaciones/buscarOrden',
            type: 'POST',
            data: {
                nro_orden: $("#annio").val() + "/" + $("#division").val() + pad($("#nro_orden").val(), 6)
            },
            dataType: "json",
            beforeSend: function (jqXHR) {
                $("#spinner").show();
                $("#spinner button").unbind("click");
                $("#spinner button").click(function () {
                    jqXHR.abort();
                    $("#spinner").hide();
                });
            },
            success: function (data) {
                $("#dam").val(data['CODI_ADUA'] + "-" + data['ANO_DECLA'] + "-" + data['REGI_PROC']+ "-" + data['NRO_DECLA']+ " DEL " + data['FCH_DECLA']+ " CANAL " + data['TIP_AFORO']+ " " + data['NOMB_CLTE']);
            },
            complete: function () {
                $("#spinner").hide();
                clean();
            }
        });
    }
}

function pad(num, size) {
    var s = num+"";
    while (s.length < size) s = "0" + s;
    return s;
}

function guardar() {
    if (validateForm()) {
        $.ajax({
            url: '/control/Operaciones/insertarNotificacion',
            type: 'POST',
            data: {
                idnotificacion: $("#idnotificacion").val(),
                orden: $("#annio").val() + " - " + $("#nro_orden").val(),
                dam: $("#dam").val(),
                fecha_notificacion: formatF_YMD($("#fecha_notificacion").val()),
                notificacion: $("#notificacion").val(),
                expediente: $("#expediente").val(),
                genera_multa: $("#genera_multa").val(),
                fecha_respuesta: formatF_YMD($("#fecha_respuesta").val()),
                estado: $("#estado").val(), 
                cuotas: $("#cuotas").val(),
                observacion: $("#observacion").val()
            },
            dataType: "json",
            beforeSend: function (jqXHR) {
                $("#spinner").show();
                $("#spinner button").unbind("click");
                $("#spinner button").click(function () {
                    jqXHR.abort();
                    $("#spinner").hide();
                });
            },
            success: function (data) {
                if (data === "success") {
                    $.notify({
                        title: "Sistema Ok: ",
                        message: "Registro Insertado!"
                    }, {
                        type: "success"
                    });
                } else {
                    $.notify({
                        title: "Sistema Ok: ",
                        message: "Error Insertado!"
                    }, {
                        type: "danger"
                    });
                }
            },
            complete: function () {
                $("#spinner").hide();
                clean();
            }
        });
    }
}

function Eliminar() {
    $.ajax({
        url: 'eliminar',
        type: 'POST',
        data: {
            idusuario: $("#idusuario").val()
        },
        dataType: "json",
        beforeSend: function (jqXHR) {
            $("#spinner").show();
            $("#spinner button").unbind("click");
            $("#spinner button").click(function () {
                jqXHR.abort();
                $("#spinner").hide();
            });
        },
        success: function (data) {
            if (data === "success") {
                $.notify({
                    title: "Sistema Ok: ",
                    message: "Registro Eliminado!"
                }, {
                    type: "success"
                });
            } else {
                $.notify({
                    title: "Sistema Error: ",
                    message: "Registro fallido!"
                }, {
                    type: "danger"
                });
            }
        },
        complete: function () {
            $("#spinner").hide();
            clean();
        }
    });
}

var clean = function () {
    $("#ididnotificacion").val("");
    $("#nro_documento").val("");
    $("#nombres_apellidos").val("");
    $("#idempleado_idnotificacion").val("");
    $('#idempleado_idnotificacion').trigger("chosen:updated");
    $("#idmotivo").val("");
    $('#idmotivo').trigger("chosen:updated");
    $("#observacion").val("");
    $("#empresa").val("");
};


var formatF_YMD = function (fecha) {
    if (fecha != "") {
        var Finicial = "DD/MM/YYYY";
        var Ffinal = "YYYY-MM-DD";
        var fechanew = moment(fecha, Finicial);
        return fechanew.format(Ffinal);
    }
    return fecha;
};