/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

$(document).ready(function () {
    validation();
});

var validation = function () {
    $('#myform').validate({
        lang: 'es',
        rules: {
            'nombres_apellidos': {
                required: true,
                minlength: 3,
                maxlength: 200
            },
            'idmotivo': {
                required: true,
                minlength: 3,
                maxlength: 200
            },
            'nro_documento': {
                required: true
            }
        },
        highlight: function (element) {
            $(element).closest('.form-group').addClass('has-error');
        },
        unhighlight: function (element) {
            $(element).closest('.form-group').removeClass('has-error');
        },
        errorElement: 'span',
        errorClass: 'help-block',
        errorPlacement: function (error, element) {
            if (element.parent('.input-group').length) {
                error.insertAfter(element.parent());
            } else {
                error.insertAfter(element);
            }
        }
    });
};

var validateForm = function () {
    return $('#myform').valid();
};


function guardarVisita() {
    if (validateForm()) {
        $.ajax({
            url: '/control/visitas/insertarVisita',
            type: 'POST',
            data: {
                idvisita: $("#idvisita").val(),
                nro_documento: $("#nro_documento").val(),
                nombres_apellidos: $("#nombres_apellidos").val(),
                idempleado_visita: $("#idempleado_visita").val(),
                idmotivo: $("#idmotivo").val(),
                observacion: $("#observacion").val(),
                empresa: $("#empresa").val()
            },
            dataType: "json",
            beforeSend: function (jqXHR) {
                $("#spinner").show();
                $("#spinner button").unbind("click");
                $("#spinner button").click(function () {
                    jqXHR.abort();
                    $("#spinner").hide();
                });
            },
            success: function (data) {
                if (data === "success") {
                    $.notify({
                        title: "Sistema Ok: ",
                        message: "Registro Insertado!"
                    }, {
                        type: "success"
                    });
                } else {
                    $.notify({
                        title: "Sistema Ok: ",
                        message: "Error Insertado!"
                    }, {
                        type: "danger"
                    });
                }
            },
            complete: function () {
                $("#spinner").hide();
                cleanVisita();
            }
        });
    }
}

function EliminarVisita() {
    $.ajax({
        url: 'eliminarVisita',
        type: 'POST',
        data: {
            idusuario: $("#idusuario").val()
        },
        dataType: "json",
        beforeSend: function (jqXHR) {
            $("#spinner").show();
            $("#spinner button").unbind("click");
            $("#spinner button").click(function () {
                jqXHR.abort();
                $("#spinner").hide();
            });
        },
        success: function (data) {
            if (data === "success") {
                $.notify({
                    title: "Sistema Ok: ",
                    message: "Registro Eliminado!"
                }, {
                    type: "success"
                });
            } else {
                $.notify({
                    title: "Sistema Error: ",
                    message: "Registro fallido!"
                }, {
                    type: "danger"
                });
            }
        },
        complete: function () {
            $("#spinner").hide();
            cleanVisita();
        }
    });
}

var cleanVisita = function () {
    $("#idvisita").val("");
    $("#nro_documento").val("");
    $("#nombres_apellidos").val("");
    $("#idempleado_visita").val("");
    $('#idempleado_visita').trigger("chosen:updated");
    $("#idmotivo").val("");
    $('#idmotivo').trigger("chosen:updated");
    $("#observacion").val("");
    $("#empresa").val("");
};

$('#nro_documento').on('keypress', function (e) {
    if (e.which === 13) {
        $.ajax({
            url: '/control/visitas/consultarDNI',
            type: 'POST',
            dataType: "json",
            beforeSend: function (jqXHR) {
                $("#spinner").show();
                $("#spinner button").unbind("click");
                $("#spinner button").click(function () {
                    jqXHR.abort();
                    $("#spinner").hide();
                });
            },
            data: {
                nro_documento: $('#nro_documento').val()
            },
            success: function (data) {
                if (data == "|||DNI no encontrado en Padrón Electoral ") {
                    $.notify({
                        title: "Sistema Error: ",
                        message: "DNI no encontrado en Padrón Electoral!"
                    }, {
                        type: "danger"
                    });
                } else {
                    $("#nombres_apellidos").val(data.replace("|", " ").replace("|", " "));
                }

            },
            complete: function () {
                $("#spinner").hide();
            }
        });
    }
});