/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

$(document).ready(function () {
    validation();
});

var validation = function () {
    $('#myform').validate({
        lang: 'es',
        rules: {
            'remitente': {
                required: true,
                minlength: 3,
                maxlength: 200
            },
            'fecha_recepcion': {
                required: true,
                minlength: 3,
                maxlength: 200
            },
            'codigo_paquete': {
                required: true
            }
        },
        highlight: function (element) {
            $(element).closest('.form-group').addClass('has-error');
        },
        unhighlight: function (element) {
            $(element).closest('.form-group').removeClass('has-error');
        },
        errorElement: 'span',
        errorClass: 'help-block',
        errorPlacement: function (error, element) {
            if (element.parent('.input-group').length) {
                error.insertAfter(element.parent());
            } else {
                error.insertAfter(element);
            }
        }
    });
};

var validateForm = function () {
    return $('#myform').valid();
};


function guardarPaquete() {
    if (validateForm()) {
        $.ajax({
            url: '/control/paquetes/insertarPaquete',
            type: 'POST',
            data: {
                idpaquetes_correo: $("#idpaquetes_correo").val(),
                remitente: $("#remitente").val(),
                fecha_recepcion: formatF_YMD($("#fecha_recepcion").val()),
                hora_llegada: $("#hora_llegada").val(),
                conforme: $("#conforme").val(),
                idempleado_recepciona: $("#idempleado_recepciona").val(),
                firma: $("#firma").val(),
                observacion: $("#observacion").val(),
                codigo_paquete: $("#codigo_paquete").val()
            },
            dataType: "json",
            beforeSend: function (jqXHR) {
                $("#spinner").show();
                $("#spinner button").unbind("click");
                $("#spinner button").click(function () {
                    jqXHR.abort();
                    $("#spinner").hide();
                });
            },
            success: function (data) {
                if (data === "success") {
                    $.notify({
                        title: "Sistema Ok: ",
                        message: "Registro Insertado!"
                    }, {
                        type: "success"
                    });
                } else {
                    $.notify({
                        title: "Sistema Ok: ",
                        message: "Error Insertado!"
                    }, {
                        type: "danger"
                    });
                }
            },
            complete: function () {
                $("#spinner").hide();
                cleanPaquete();
            }
        });
    }
}

function EliminarPaquete() {
    $.ajax({
        url: 'eliminarPaquete',
        type: 'POST',
        data: {
            idusuario: $("#idusuario").val()
        },
        dataType: "json",
        beforeSend: function (jqXHR) {
            $("#spinner").show();
            $("#spinner button").unbind("click");
            $("#spinner button").click(function () {
                jqXHR.abort();
                $("#spinner").hide();
            });
        },
        success: function (data) {
            if (data === "success") {
                $.notify({
                    title: "Sistema Ok: ",
                    message: "Registro Eliminado!"
                }, {
                    type: "success"
                });
            } else {
                $.notify({
                    title: "Sistema Error: ",
                    message: "Registro fallido!"
                }, {
                    type: "danger"
                });
            }
        },
        complete: function () {
            $("#spinner").hide();
            cleanPaquete();
        }
    });
}

var cleanPaquete = function () {
    $("#idpaquetes_correo").val("");
    $("#remitente").val("");
    $("#conforme").val("");
    $("#idempleado_recepciona").val("");
    $('#idempleado_recepciona').trigger("chosen:updated");
    $("#firma").val("");
    $("#observacion").val("");
};

$('#nro_documento').on('keypress', function (e) {
    if (e.which === 13) {
        $.ajax({
            url: '/control/paquetes/consultarDNI',
            type: 'POST',
            dataType: "json",
            beforeSend: function (jqXHR) {
                $("#spinner").show();
                $("#spinner button").unbind("click");
                $("#spinner button").click(function () {
                    jqXHR.abort();
                    $("#spinner").hide();
                });
            },
            data: {
                nro_documento: $('#nro_documento').val()
            },
            success: function (data) {
                if (data == "|||DNI no encontrado en Padrón Electoral ") {
                    $.notify({
                        title: "Sistema Error: ",
                        message: "DNI no encontrado en Padrón Electoral!"
                    }, {
                        type: "danger"
                    });
                } else {
                    $("#nombres_apellidos").val(data.replace("|", " ").replace("|", " "));
                }

            },
            complete: function () {
                $("#spinner").hide();
            }
        });
    }
});

var formatF_YMD = function (fecha) {
    if (fecha != "") {
        var Finicial = "DD/MM/YYYY";
        var Ffinal = "YYYY-MM-DD";
        var fechanew = moment(fecha, Finicial);
        return fechanew.format(Ffinal);
    }
    return fecha;
};