$(document).ready(function () {

    validation();

});

var validateForm = function () {
    return $('#myform').valid();
};


var validation = function () {
    $('#myform').validate({
        lang: 'es',
        rules: {
            'fecha': {
                required: true
            },
            'cantidad_horas': {
                required: true
            },
            'idusuario': {
                required: true
            },
            'motivo': {
                required: true
            },
        },
        highlight: function (element) {
            $(element).closest('.form-group').addClass('has-error');
        },
        unhighlight: function (element) {
            $(element).closest('.form-group').removeClass('has-error');
        },
        errorElement: 'span',
        errorClass: 'help-block',
        errorPlacement: function (error, element) {
            if (element.parent('.input-group').length) {
                error.insertAfter(element.parent());
            } else {
                error.insertAfter(element);
            }
        }
    }); 
};

function guardarAusencia() {
    if (validateForm()) {
        $.ajax({
            url: 'insertarExtras',
            type: 'POST',
            data: {
                fecha: $("#fecha").val(),
                cantidad_horas: $("#cantidad_horas").val(),
                idusuario: $("#idusuario").val(),
                motivo: $("#motivo").val(),
                observacion: $("#observacion").val()
            },
            dataType: "json",
            beforeSend: function (jqXHR) {
                $("#spinner").show();
                $("#spinner button").unbind("click");
                $("#spinner button").click(function () {
                    jqXHR.abort();
                    $("#spinner").hide();
                });
            },
            success: function (data) {
                if (data === "success") {
                    $.notify({
                        title: "Sistema Ok: ",
                        message: "Registro Insertado!"
                    }, {
                        type: "success"
                    });
                }

            },
            complete: function () {
                $("#spinner").hide();
            }
        });
    }
}