window.map;
window.apiGeolocation;

$(document).ready(() => {
    showSpinner();
});

function showSpinner() {
    $("#spinner").show();
    $("#spinner button").unbind("click");
    $("#spinner button").click(function () {
        jqXHR.abort();
        $("#spinner").hide();
    });
}

// Initialize and add the map
function initMap() {

    // The location of Uluru
    const uluru = { lat: window.apiGeolocation.latitude, lng: window.apiGeolocation.longitude };
    // The map, centered at Uluru
    window.map = new google.maps.Map(document.getElementById("map"), {
        zoom: 17,
        center: uluru,
        scrollwheel: false,
        navigationControl: false,
        mapTypeControl: false,
        scaleControl: false,
        draggable: false,
    });
    // The marker, positioned at Uluru
    const marker = new google.maps.Marker({
        position: uluru,
        map: map,
    });
}

window.initMap = initMap;



var apiGeolocationSuccess = function (position) {
    apiGeolocation = { latitude: position.coords.latitude, longitude: position.coords.longitude, message: `API geolocation success` }
    changePointInMap(apiGeolocation);
    console.log("API geolocation success!\n\nlat = " + position.coords.latitude + "\nlng = " + position.coords.longitude);
};

var tryAPIGeolocation = function () {
    jQuery.post("https://www.googleapis.com/geolocation/v1/geolocate?key=AIzaSyCJnKas9-vLOM-Fx-Vo6Z9QHnP-gVCgSXE", function (success) {
        apiGeolocationSuccess({ coords: { latitude: success.location.lat, longitude: success.location.lng } });
    })
        .fail(function (err) {
            console.log("API Geolocation error! \n\n", err);
        });
};

var browserGeolocationSuccess = function (position) {
    apiGeolocation = { latitude: position.coords.latitude, longitude: position.coords.longitude, message: `Browser geolocation success` }
    changePointInMap(apiGeolocation);
    console.log("Browser geolocation success!\n\nlat = " + position.coords.latitude + "\nlng = " + position.coords.longitude);
};

var browserGeolocationFail = function (error) {
    console.log(error);
    switch (error.code) {
        case error.TIMEOUT:
            console.log("Browser geolocation error !\n\nTimeout.");
            tryAPIGeolocation();
            break;
        case error.PERMISSION_DENIED:
            let confirmación = confirm("Por favor Activar Ubicación Activar Ubicación");
            if (confirmación) {
                tryGeolocation();
            }
            break;
        case error.POSITION_UNAVAILABLE:
            console.log("Browser geolocation error !\n\nPosition unavailable.");
            tryAPIGeolocation();
            break;
    }
};

var tryGeolocation = function () {
    if (navigator.geolocation) {
        navigator.geolocation.getCurrentPosition(
            browserGeolocationSuccess,
            browserGeolocationFail,
            { maximumAge: 50000, timeout: 20000, enableHighAccuracy: true });
    }
};

tryGeolocation();

var changePointInMap = function (apiGeolocation) {
    window.apiGeolocation = apiGeolocation;
    initMap();
    $("#spinner").hide();
}

var mostrarModalObservación = function () {
    $("#modalObservación").modal("show");
}

var registrarIncidencia = function () {
    $.ajax({
        url: 'insertaringresoIncidencia',
        type: 'POST',
        data: {
            ...window.apiGeolocation,
            observacion: $("#observacion").val(),
        },
        dataType: "json",
        beforeSend: function (jqXHR) {
            $("#modalObservación textarea").val("");
            $("#modalObservación").modal("hide");

            $("#spinner").show();
            $("#spinner button").unbind("click");
            $("#spinner button").click(function () {
                jqXHR.abort();
                $("#spinner").hide();
            });
        },
        success: function (data) {
            console.log(data);
            if (data === "success") {
                $.notify({
                    title: "Sistema Ok: ",
                    message: "Registro Insertado!"
                }, {
                    type: "success"
                });
                $("#spinner").hide();
            } else {
                $.notify({
                    title: "Sistema Error: ",
                    message: "Error al guardar intente más tarde"
                }, {
                    type: "danger"
                });
                $("#spinner").hide();
            }
        },
        error: function (xhr, ajaxOptions, thrownError) {
            $.notify({
                title: "Sistema Error: ",
                message: "Error al guardar intente contacte al administrador"
            }, {
                type: "danger"
            });
        },
        complete: function () {
            $("#spinner").hide();
        }
    });
}