/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

var mDefaultDataTableInstance;
var sampleTable;


$(document).ready(function () {
    initTable();
    sampleTable = $('#myTable').DataTable(mDefaultDataTableInstance);
    validation();
    filtrarReloj(0);
    $('#myTable tbody').on('click', 'tr', function () {
        detalles($($(this).find("input")[0]).val());
        $('#myTable tbody tr').removeClass('table-info');
        $(this).addClass('table-info');
    });

});

var validation = function () {
    $('#myform').validate({
        lang: 'es',
        rules: {
            'usuario': {
                required: true,
                minlength: 3,
                maxlength: 200
            },
            'codigo': {
                required: true,
                minlength: 3,
                maxlength: 200
            },
            'perfil': {
                required: true
            },
            'nombre': {
                required: true
            }
        },
        highlight: function (element) {
            $(element).closest('.form-group').addClass('has-error');
        },
        unhighlight: function (element) {
            $(element).closest('.form-group').removeClass('has-error');
        },
        errorElement: 'span',
        errorClass: 'help-block',
        errorPlacement: function (error, element) {
            if (element.parent('.input-group').length) {
                error.insertAfter(element.parent());
            } else {
                error.insertAfter(element);
            }
        }
    });
};

var validateForm = function () {
    return $('#myform').valid();
};

function initTable() {
    mDefaultDataTableInstance = {
        "pageLength": 10,
        "bLengthChange": true,
        "bFilter": true,
        "bProcessing": true,
        "pagingType": "full_numbers",
        "ordering": false,
        "oLanguage": {
            "sInfo": 'Nro de Registro: _START_ a _END_ de _TOTAL_',
            "sInfoEmpty": 'Hay un total de _TOTAL_ registros',
            "sEmptyTable": 'No hay registros para mostrar',
            "sZeroRecords": 'There are no matching <span class="lvllbl"></span>(s) to display',
            "sProcessing": 'Cargando',
            "oPaginate": {
                "sFirst": '<i class="fa fa-angle-double-left"></i>', // This is the link to the first page
                "sPrevious": '<i class="fa fa-angle-left"></i>', // This is the link to the previous page
                "sNext": '<i class="fa fa-angle-right"></i>', // This is the link to the next page
                "sLast": '<i class="fa fa-angle-double-right"></i>' // This is the link to the last page
            }
        },
        "rowCallback": function (row, data, index) {
            $('td', row).eq(0).addClass('text-center nowrap');
            $('td', row).eq(1).addClass('text-center nowrap');
            $('td', row).eq(2).addClass('text-center nowrap');
            $('td', row).eq(3).addClass('text-center nowrap');
            $('td', row).eq(4).addClass('text-center nowrap');
            $('td', row).eq(0).html("<input id='idusuarioList' name='idusuarioList' type='hidden' value='" + data[3] + "'/>" + data[0] + "");
            $('td', row).eq(5).html("");
        }
    }; 
}



function guardarReloj() {
    if (validateForm()) {
        $.ajax({
            url: 'insertarReloj',
            type: 'POST',
            data: {
                
                idusuario: $("#idusuario").val(),
                codigo: $("#codigo").val(),
                dni: $("#dni").val(),
                nombre: $("#nombre").val(),
                idcodigo: $("#idcodigo").val()
            },
            dataType: "json",
            beforeSend: function (jqXHR) {
                $("#spinner").show();
                $("#spinner button").unbind("click");
                $("#spinner button").click(function () {
                    jqXHR.abort();
                    $("#spinner").hide();
                });
            },
            success: function (data) {
                if (data === "success") {
                    $.notify({
                        title: "Sistema Ok: ",
                        message: "Registro Insertado!"
                    }, {
                        type: "success"
                    });

                    filtrarReloj(1);
                } else {
                    $.notify({
                        title: "Sistema Ok: ",
                        message: "Error Insertado!"
                    }, {
                        type: "danger"
                    });
                }
            },
            complete: function () {
                $("#spinner").hide();
            }
        });
    }
}

function EliminarReloj() {
    $.ajax({
        url: 'eliminarReloj',
        type: 'POST',
        data: {
            idcodigo: $("#idcodigo").val()
        },
        dataType: "json",
        beforeSend: function (jqXHR) {
            $("#spinner").show();
            $("#spinner button").unbind("click");
            $("#spinner button").click(function () {
                jqXHR.abort();
                $("#spinner").hide();
            });
        },
        success: function (data) {
            if (data === "success") {
                $.notify({
                    title: "Sistema Ok: ",
                    message: "Registro Eliminado!"
                }, {
                    type: "success"
                });
            } else {
                $.notify({
                    title: "Sistema Error: ",
                    message: "Registro fallido!"
                }, {
                    type: "danger"
                });
            }

        },
        complete: function () {
            $("#spinner").hide();
            filtrarReloj(1);
        }
    });
}

var validateForm = function () {
    return $('#myform').valid();
};

var filtrarReloj = function (parametro) {
    if (parametro == "1") {
        cleanReloj();
    }
    $.ajax({
        url: 'filtroReloj',
        type: 'POST',
        dataType: "json",
        beforeSend: function (jqXHR) {
            $("#spinner").show();
            $("#spinner button").unbind("click");
            $("#spinner button").click(function () {
                jqXHR.abort();
                $("#spinner").hide();
            });
        },
        success: function (data) {
            listadoReloj(data);
        },
        complete: function () {
            $("#spinner").hide();
        }
    });
    $("#botonLimpiar").css("display", "inline");
    $("#botonCancelar").css("display", "none");
    $("#botonEliminar").css("display", "none");

};

var detalles = function (id) {
    $.ajax({
        url: 'filtroReloj',
        type: 'POST',
        dataType: "json",
        beforeSend: function (jqXHR) {
            $("#spinner").show();
            $("#spinner button").unbind("click");
            $("#spinner button").click(function () {
                jqXHR.abort();
                $("#spinner").hide();
            });
        },
        data: {
            idcodigo: id
        },
        success: function (data) {
            $("#idcodigo").val(data[0]['idcodigo']);
            $("#codigo").val(data[0]['codigo']);
             $("#dni").val(data[0]['dni']);
            $("#nombre").val(data[0]['nombre']);
            $("#idusuario").val(data[0]['idusuario']);
            $('#idusuario').trigger("chosen:updated");
        },
        complete: function () {
            $("#spinner").hide();
        }
    });
};

var cleanReloj = function () {
    $("#idusuario").val("");
    $("#dni").val("");
    $("#codigo").val("");
    $("#idusuario").val("");
    $('#idusuario').trigger("chosen:updated");
    $("#nombre").val("");
    $('#nombre').trigger("chosen:updated");
    $("#idcodigo").val("");
    
};

var listadoReloj = function (data) {
    sampleTable.clear();
    $.each(data, function (i, items) {
        sampleTable.row.add([
            items['codigo'],
            items['dni'],
            items['nombre'],
            items['idcodigo'],
            
        ]).draw();
    });
};

