/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

var mDefaultDataTableInstance;
var sampleTable;
$(document).ready(function () {
    initTable();
    sampleTable = $('#myTable').DataTable(mDefaultDataTableInstance);
});
var filtroSaldos = function () {
    $.ajax({
        url: '/control/reportes/filtroSaldosCliente',
        type: 'POST',
        dataType: "json",
        data: {
            fch_desde: $("#fch_desde").val(),
            fch_hasta: $("#fch_hasta").val(),
            cliente: $("#cliente").val(),
            ctrl_detra: $("#ctrl_detra").val()
        },
        beforeSend: function (jqXHR) {
            $("#spinner").show();
            $("#spinner button").unbind("click");
            $("#spinner button").click(function () {
                jqXHR.abort();
                $("#spinner").hide();
            });
        },
        success: function (data) {
            listadoPaquete(data);
        },
        complete: function () {
            $("#spinner").hide();
        }
    });
};



function initTable() {
    mDefaultDataTableInstance = {
        dom: 'Bfrtip',
        buttons: [
            'copy', 'csv', 'excel', 'pdf', 'print',
            {
                extend: 'excelHtml5'
            }
        ],
        "pageLength": 10,
        "bLengthChange": true,
        "bFilter": true,
        "bProcessing": true,
        "pagingType": "full_numbers",
        "ordering": false,
        "oLanguage": {
            "sInfo": 'Nro de Registro: _START_ a _END_ de _TOTAL_',
            "sInfoEmpty": 'Hay un total de _TOTAL_ registros',
            "sEmptyTable": 'No hay registros para mostrar',
            "sZeroRecords": 'There are no matching <span class="lvllbl"></span>(s) to display',
            "sProcessing": 'Cargando',
            "oPaginate": {
                "sFirst": '<i class="fa fa-angle-double-left"></i>', // This is the link to the first page
                "sPrevious": '<i class="fa fa-angle-left"></i>', // This is the link to the previous page
                "sNext": '<i class="fa fa-angle-right"></i>', // This is the link to the next page
                "sLast": '<i class="fa fa-angle-double-right"></i>' // This is the link to the last page
            }
        },
        "rowCallback": function (row, data, index) {
            $('td', row).eq(0).addClass('text-center');
            $('td', row).eq(1).addClass('text-center');
            $('td', row).eq(2).addClass('text-center');
            $('td', row).eq(3).addClass('text-center');
            $('td', row).eq(4).addClass('text-center');
            $('td', row).eq(5).addClass('text-center');
            $('td', row).eq(6).addClass('text-center');
            $('td', row).eq(7).addClass('text-center');
            $('td', row).eq(8).addClass('text-center');
            $('td', row).eq(9).addClass('text-center');
            var res = data['NRO_DCTO'].split("=");
            $('td', row).eq(0).html("<a onclick=\"asignarMensajero('" + res[0] + "', '" + res[1] + "')\" title='Asignar' data-toggle='modal' data-target='#smallmodal' style='color:blue;'>" + data['NRO_DCTO'] + "</a>");
        }
    };
}

function asignarMensajero(tipo, id) {
    $.ajax({
        url: 'detalle_saldo',
        type: 'POST',
        dataType: "json",
        data: {
            NRO_DCTO: id,
            tipo: tipo
        },
        beforeSend: function (jqXHR) {
            $("#spinner").show();
            $("#spinner button").unbind("click");
            $("#spinner button").click(function () {
                jqXHR.abort();
                $("#spinner").hide();
            });
        },
        success: function (data) {
            var html = "<table border = '1'>";
            html = html + "<thead>";
            html = html + "<tr>";
            html = html + "<td>Conceto</td>";
            html = html + "<td>Detalle</td>";
            html = html + "<td>Moneda</td>";
            html = html + "<td>Importe</td>";
            html = html + "<td>IGV</td>";
            html = html + "</tr>";
            html = html + "</thead>";
            html = html + "<tbody>";
            $.each(data, function (i, items) {
                html = html + "<tr>";
                html = html + "<td>" + items['CONCEPTO'] + "</td>";
                html = html + "<td>" + items['DCTO_PROV'] + "</td>";
                html = html + "<td>" + items['TIP_MONE'] + "</td>";
                html = html + "<td>" + items['IMPO_SOL'] + "</td>";
                if (tipo == 'F') {
                    html = html + "<td>" + items['IMPO_IGV'] + "</td>";
                } else {
                    html = html + "<td></td>";

                }

                html = html + "</tr>";
            });
            html = html + "</table>";
            html = html + "</tbody>";
            $("#modalin").html(html);
        },
        complete: function () {
            $("#spinner").hide();
        }
    });
}
var listadoPaquete = function (data) {
    sampleTable.clear().rows.add(data).draw();
};

