/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

var mDefaultDataTableInstance;
var sampleTable;


$(document).ready(function () {
    initTable();
    sampleTable = $('#myTable').DataTable(mDefaultDataTableInstance);
    filtrarVisita();
});

function initTable() {
    mDefaultDataTableInstance = {
        "pageLength": 10,
        "bLengthChange": true,
        "bFilter": true,
        "bProcessing": true,
        "pagingType": "full_numbers",
        "ordering": false,
        "oLanguage": {
            "sInfo": 'Nro de Registro: _START_ a _END_ de _TOTAL_',
            "sInfoEmpty": 'Hay un total de _TOTAL_ registros',
            "sEmptyTable": 'No hay registros para mostrar',
            "sZeroRecords": 'There are no matching <span class="lvllbl"></span>(s) to display',
            "sProcessing": 'Cargando',
            "oPaginate": {
                "sFirst": '<i class="fa fa-angle-double-left"></i>', // This is the link to the first page
                "sPrevious": '<i class="fa fa-angle-left"></i>', // This is the link to the previous page
                "sNext": '<i class="fa fa-angle-right"></i>', // This is the link to the next page
                "sLast": '<i class="fa fa-angle-double-right"></i>' // This is the link to the last page
            }
        },
        "rowCallback": function (row, data, index) {
            $('td', row).eq(0).addClass('text-center');
            $('td', row).eq(1).addClass('text-center');
            $('td', row).eq(2).addClass('text-center');
            $('td', row).eq(3).addClass('text-center');
            $('td', row).eq(4).addClass('text-center');
            $('td', row).eq(5).addClass('text-center');
            $('td', row).eq(6).addClass('text-center');
            $('td', row).eq(7).addClass('text-center');
            $('td', row).eq(8).addClass('text-center');
            $('td', row).eq(9).addClass('text-center');
            if (data[9] == "1") {
                $('td', row).eq(9).html('En Oficina');
            } else if (data[9] == "2") {
                $('td', row).eq(9).html('Concluido');
            } else {
                $('td', row).eq(9).html('Anulado');
            }
            $('td', row).eq(10).addClass('text-center');
            if (data[10].length > 30) {
                $('td', row).eq(10).html("<spam title='" + data[10] + "'> " + data[10].substr(0, 30) + "..." + "</spam>");
            } else {
                $('td', row).eq(10).html(data[10]);
            }

            $('td', row).eq(11).addClass('text-center');
            var url = "/control/visitas/actualizar/" + data[11];
            if (data[9] == "1") {
                $('td', row).eq(11).html("<a href='" + url + "' title='Modificar'><i class='menu-icon fa fa-pencil'></i></a> &nbsp;\n\
            <a onclick='envioParameter(" + data[11] + ")' title='Confirmar Salida' data-toggle='modal' data-target='#smallmodal'><i class='menu-icon fa  fa-check-circle'></i></a>&nbsp;\n\
            <a onclick='envioParameterDelete(" + data[11] + ")' title='Anular Registro' data-toggle='modal' data-target='#smallmodal2'><i class='menu-icon fa  fa-minus-square'></i></a>");
            } else {
                $('td', row).eq(11).html("Orden Concluida");
            }

        }
    };
}

function envioParameter(id) {
    $("#idvisitaParameter").val(id);
}

function envioParameterDelete(id) {
    $("#idvisitaParameterDelete").val(id);
}

function registrarSalida() {
    $("#smallmodal").modal('hide');
    $.ajax({
        url: '/control/visitas/registrarSalida',
        type: 'POST',
        data: {
            idvisita: $("#idvisitaParameter").val()
        },
        dataType: "json",
        beforeSend: function (jqXHR) {
            $("#spinner").show();
            $("#spinner button").unbind("click");
            $("#spinner button").click(function () {
                jqXHR.abort();
                $("#spinner").hide();
            });
        },
        success: function (data) {
            if (data === "success") {
                $.notify({
                    title: "Sistema Ok: ",
                    message: "Registro Eliminado!"
                }, {
                    type: "success"
                });
            } else {
                $.notify({
                    title: "Sistema Error: ",
                    message: "Registro fallido!"
                }, {
                    type: "danger"
                });
            }

        },
        complete: function () {
            $("#spinner").hide();
            filtrarVisita();
        }
    });
}

function anularRegistro() {
    $.ajax({
        url: '/control/visitas/anularRegistro',
        type: 'POST',
        data: {
            idvisita: $("#idvisitaParameterDelete").val()
        },
        dataType: "json",
        beforeSend: function (jqXHR) {
            $("#spinner").show();
            $("#spinner button").unbind("click");
            $("#spinner button").click(function () {
                jqXHR.abort();
                $("#spinner").hide();
            });
        },
        success: function (data) {
            if (data === "success") {
                $.notify({
                    title: "Sistema Ok: ",
                    message: "Registro Eliminado!"
                }, {
                    type: "success"
                });
            } else {
                $.notify({
                    title: "Sistema Error: ",
                    message: "Registro fallido!"
                }, {
                    type: "danger"
                });
            }

        },
        complete: function () {
            $("#spinner").hide();
            filtrarVisita();
        }
    });
}

var validateForm = function () {
    return $('#myform').valid();
};

var filtrarVisita = function () {
    $.ajax({
        url: '/control/visitas/filtroVisita',
        type: 'POST',
        dataType: "json",
        beforeSend: function (jqXHR) {
            $("#spinner").show();
            $("#spinner button").unbind("click");
            $("#spinner button").click(function () {
                jqXHR.abort();
                $("#spinner").hide();
            });
        },
        success: function (data) {
            listadoVisita(data);
        },
        complete: function () {
            $("#spinner").hide();
        }
    });

};

var listadoVisita = function (data) {
    sampleTable.clear();
    $.each(data, function (i, items) {
        sampleTable.row.add([
            items['annio'] + "-" + items['codigo'],
            items['fecha'],
            items['hora_ingreso'],
            items['hora_salida'],
            items['nombres_apellidos'],
            items['nro_documento'],
            items['empresa'],
            items['nombre'],
            items['motivo'],
            items['estado'],
            items['observacion'],
            items['idvisita']
        ]).draw();
    });
};

